/*
	t@C : CDHashMap.h
	e         : CD-DA ։pnbV\
	     : Mac OS 9.x c Mac OS 8.6 ȍ~ + CarbonLib 1.0 ȍ~
	               Mac OS X   c Mac OS X 10.1 ȍ~
	l         : 1. Audio CD }EgĂȂꍇA
	                  ։̌Ɏgp
*/
#ifndef __CDHASHMAP__
#define __CDHASHMAP__

#ifndef _NEW
#include <new>
#endif
#ifndef __CARBON__
#include "Carbon.h"
#endif

class CDHashMap
{
	public :
		//RXgN^EfBXgN^
									CDHashMap(UInt32,
											  CFArrayRef = NULL) throw(std::bad_alloc);
									CDHashMap(const CDHashMap&)  throw();
		virtual						~CDHashMap(void)             throw();

		//Zq
		CDHashMap&					operator=(const CDHashMap&)  throw();
		UInt32						operator[](CFStringRef)      const throw();

		//o֐
		CDHashMap					Clone(void)                  const throw(std::bad_alloc);

		//ANZbT
		bool						itemIfExists(CFStringRef,
												 UInt32&)        const throw();
		bool						exists(CFStringRef)          const throw();
		UInt32						maxTrackNo(void)             const throw();

	private :
									CDHashMap(void);			 ///

		//RXgN^EfBXgN^
									CDHashMap(UInt32,
											  CFDictionaryRef)   throw(std::bad_alloc);

		//o֐
		void						Initialize(const CDHashMap&) throw();
		void						Dispose(void)                throw();

		//f[^o`
		UInt32						maxTrackNo_;
		CFDictionaryRef				trackMap_;

		//static o֐
		static CFDictionaryRef		Init(UInt32,
										 CFArrayRef)             throw(std::bad_alloc);

		//static f[^o`
		///WgbÑev[g
		static const UInt32			kTmplCount;
		static const char*			kTrackTmpl[];
};

//CC֐
/*
	ANZXw : public
	      ֐ : CDHashMap::CDHashMap
	        @\ : ։pnbV\̃Rs[RXgN^
	         : ui32MaxTrackNo      gbNԍ̍ől
	        O : std::bad_alloci Ɏsꍇ j
	        l : 
*/
inline						CDHashMap::CDHashMap(const CDHashMap&	OBJ_SRC_REF) throw() : 
							maxTrackNo_(0),
							trackMap_(NULL)
{
	//
	Initialize(OBJ_SRC_REF);
};

/*
	ANZXw : public, const
	      ֐ : CDHashMap::operator=
	        @\ : Azz񉉎Zq
	         : strIndex      ։t@C
	      ߂l : ։t@CɑΉgbNԍւ̎Q
	        O : 
	        l : 1. ͈ɑΉvfȂꍇA0 Ԃ
*/
inline CDHashMap&			CDHashMap::operator=(const CDHashMap&	OBJ_SRC_REF) throw()
{
	//p[^
	if(trackMap_ == OBJ_SRC_REF.trackMap_)
		return *this;

	//
	Dispose();
	Initialize(OBJ_SRC_REF);
	return *this;
};

/*
	ANZXw : public, const
	      ֐ : CDHashMap::operator[]
	        @\ : Azz񉉎Zq
	         : strIndex      ։t@C
	      ߂l : ։t@CɑΉgbNԍւ̎Q
	        O : 
	        l : 1. ͈ɑΉvfȂꍇA0 Ԃ
*/
inline UInt32				CDHashMap::operator[](CFStringRef	strKey) const throw()
{
	//ϐ錾
	bool						bRet;
	UInt32						ui32Value;

	//
	bRet = itemIfExists(strKey,
						ui32Value);
	return (bRet ? ui32Value : 0UL);
};

/*
	ANZXw : public, const
	      ֐ : CDHashMap::Clone
	        @\ : Azz̕쐬
	         : 
	      ߂l : Azz̕
	        O : std::bad_alloci ̍쐬Ɏsꍇ j
	        l : 
*/
inline CDHashMap			CDHashMap::Clone(void) const throw(std::bad_alloc)
{
	//
	return CDHashMap(maxTrackNo_,
					 trackMap_);
};

/*
	ANZXw : public, const
	      ֐ : CDHashMap::exists
	        @\ : Azzvf݂邩
	         : strIndex            ։t@C
	      ߂l :  true : ։t@ĈɑΉvf݂͑
				   false : ։t@ĈɑΉvf݂͑Ȃ
	        O : 
	        l : 
*/
inline bool					CDHashMap::exists(CFStringRef	strKey) const throw()
{
	//ϐ錾
	UInt32						ui32Value;

	//
	return itemIfExists(strKey,
						ui32Value);
};

/*
	ANZXw : public, const
	      ֐ : CDHashMap::maxTrackNo
	        @\ : ։t@C̈ꗗŔF\ȍőgbNԍ𓾂
	         : 
	      ߂l : ։t@C̈ꗗŔF\ȍőgbNԍ
	        O : 
	        l : 
*/
inline UInt32				CDHashMap::maxTrackNo(void) const throw()
{
	return maxTrackNo_;
};

#endif	//__CDHASHMAP__