/*
	t@C : CDSound.h
	e         : CD-DA ։tNX
	     : Mac OS 9.x c Mac OS 8.6 ȍ~ + CarbonLib 1.0 ȍ~
	               Mac OS X   c Mac OS X 10.1 ȍ~
	l         : 1. Audio CD }EgĂȂꍇɎgp
*/
#ifndef __CDSOUND__
#define __CDSOUND__

#ifndef _NEW
#include <new>
#endif
#ifndef __MOVIES__
#include <QuickTime/Movies.h>
#endif
#ifndef __CDDRIVER__
#include "CDDriver.h"
#endif

//#ifndef __CDHASHMAP__
//#include "CDHashMap.h"
//#endif

#include "CDHashMap.h"

class CDSound
{
	public :
		//RXgN^EfBXgN^
									CDSound(void)              throw(std::bad_alloc);
									CDSound(CFArrayRef)        throw(std::bad_alloc);
		virtual						~CDSound(void)             throw();
		//o֐
		OSErr						PlayTrack(UInt32)          throw();
		void						PauseTrack(bool)           throw();
		void						StopTrack(void)            throw();
		void						PlayTask(void)             throw();
		void						Update(void)               throw(std::bad_alloc);
		//ANZbT
		void						SetVolume(SInt16)          throw();
		SInt16						GetVolume(void)            throw();
		CDCtrlAudioState			AudioStatus(void)          throw();
		OSErr						GetPlayingInfo(UInt32*,
												   MSFRecord*) throw();
		bool						Repeat(void)               throw();
		void						Repeat(bool)               throw();
		UInt32						GetTrackCount(void)        throw();
		MSFRecord					GetTotalTime(void)         throw();
		OSErr						GetTrackInfo(UInt32,
												 MSFRecord*)   throw();

	private :
									CDSound(const CDSound&);
		const CDSound&				operator=(const CDSound&);
		//o֐
		void						Init(void)  throw(std::bad_alloc);
		void						Clear(void) throw();
		//f[^o`
		///t
		UInt32						playTrackNo_;
		Movie						playTrack_;
		SInt16						trackRefNum_;
		SInt16						volume_;
		bool						pause_;
		bool						repeat_;
		///tgbN
		MSFRecord					totalTime_;
		UInt32						trackCount_;
		MSFRecord*					times_;
		FSRefPtr*					tracks_;

		CDHashMap					hashMap_;
		//static f[^o`
		///őgbNԍ
		static const UInt32			kMaxTrackNo;
		///[r[^CXP[萔
		static const TimeScale		kFrameTimeScale;
		///[r[ʂ̏ltO
		static const SInt16			kDefaltVolume;
		/// MSFRecord
		static const MSFRecord		kInvalidTime;
};

#endif	//__CDSOUND__