/*
	t@C : CDDA.h
	e         : Mac OS 9.x / Mac OS X p CDDA tNXC^[tF[X
	     : Mac OS 9.x c Mac OS 8.6 ȍ~ + CarbonLib 1.2 ȍ~
	               Mac OS X   c Mac OS X 10.1 ȍ~
	l         : 1. CDDA IuWFNggp@
				       a). CDDA IuWFNg쐬
				             CDDA::Create() ֐gp
				             sɉ CD-DA tIuWFNg쐬B

				       b). CDDA IuWFNgj
				              delete gpāACDDA::Create() ֐œꂽ
				              CDDA IuWFNgւ̃|C^jB

				       c). gp̒
				               ECDDA IuWFNg 2 ȏ쐬ꍇ͖̓`
				               Et͒Ii : 0.05 b  1 j CDDA::Task ֐
				                 ĂяoƁB
				                 ĂяoȂꍇAt~܂AJԂtłȂA
				                 ̕sB

				       d). ̑
				               ECDDA::Create() ֐ǂ΁A
				                 Audio CD }EgĂȂꍇ͑։gpA
				                 ƂgݍނƂ\B
				                 ̏ꍇA։t[` CDDA ̃TuNXA
				                 CDDA NX̃o֐݊̃NXɂKvLB
				                 i쐬ꍇɂ CDDA.cpp  CDDA_Classic, CDDA_X Ql̎j
*/
#ifndef __CDDA__
#define __CDDA__

#ifndef _NEW
#include <new>
#endif
#ifndef __CARBON__
#include <Carbon.h>
#endif
#ifndef __CDDRIVER__
#include "CDDriver.h"
#endif

//CDDA tNX
class CDDA
{
	public :
		//fXgN^
		virtual						~CDDA(void)   throw();
		//o֐
		virtual OSStatus			Play(UInt32)  throw()     = 0;
		virtual void				Pause(bool)   throw()     = 0;
		virtual void				Stop(void)    throw()     = 0;
		virtual void				Task(void)    throw()     = 0;
		//ANZbT
		virtual UInt32				Volume(void)  throw()     = 0;
		virtual void				Volume(UInt32) throw()    = 0;
		virtual CDCtrlAudioState	AudioStatus(void) throw() = 0;
		virtual OSStatus			PlayingInfo(UInt32*,
												MSFRecord*) throw() = 0;
		virtual bool				MixedMode(void)  throw()  = 0;
		virtual UInt32				TrackCount(void) throw()  = 0;
		virtual bool				Repeat(void) throw()      = 0;
		virtual void				Repeat(bool) throw()      = 0;
		//static o֐
		static bool					Mounted(void) throw();
		static bool					Mounted(FSRef&) throw();
		static CDDA*				Create(CFArrayRef = NULL) throw(std::bad_alloc);

	protected :
		//RXgN^
									CDDA(void) throw(std::bad_alloc);

	private :
									CDDA(const CDDA&);
		const CDDA&					operator=(const CDDA&);
		//static o֐
		static bool					Mounted(FSRef*) throw();
		//static oϐ
		static OSType				kAudioCDSignature;
};

//CC֐
/*
	ANZXw : public
	      ֐ : CDDA::CDDA
	        @\ : CD-DA tNX̃RXgN^
	         : 
	        O : std::bad_alloci Ɏsꍇ j
	        l : 
*/
inline						CDDA::CDDA(void)    throw(std::bad_alloc)
{
};

/*
	ANZXw : virtual, public
	      ֐ : CDDA::~CDDA
	        @\ : CD-DA tNX̃fXgN^
	         : 
	        O : 
	        l : 
*/
inline						CDDA::~CDDA(void)   throw()
{
};

/*
	ANZXw : static, public
	      ֐ : CDDA::Mounted
	        @\ : CD-DA {[}EgĂ邩
	         : 
	      ߂l : true  c CD-DA {[̓}Eg
				   false c CD-DA {[̓}EgĂȂ
	        O : 
	        l : 1. Mac OS 8.6  MixedModeCD ̏ꍇAOS ̎dlŏ false Ԃi؁j
				      iR : fXNgbv Audio CD {[}EgȂ߁j
				   2. ). 
				      Audio CD }EgĂꍇA
				      2 Ԗڈȍ~ Audio CD {[ւ̎QƂ͊lłȂ
*/
inline bool					CDDA::Mounted(void) throw()
{
	return CDDA::Mounted(NULL);
};

/*
	ANZXw : static, public
	      ֐ : CDDA::Mounted
	        @\ : CD-DA {[}EgĂ邩
	         : fsCDVol  o    ŏɌ CD-DA {[ւ̎Q
	      ߂l : true  c CD-DA {[̓}Eg
				   false c CD-DA {[̓}EgĂȂ
	        O : 
	        l : 1. Mac OS 8.6  MixedModeCD ̏ꍇAOS ̎dlŏ false Ԃi؁j
				      iR : fXNgbv Audio CD {[}EgȂ߁j
				   2. ). 
				      Audio CD }EgĂꍇA
				      2 Ԗڈȍ~ Audio CD {[ւ̎QƂ͊lłȂ
*/
inline bool					CDDA::Mounted(FSRef&	fsCDVol) throw()
{
	return CDDA::Mounted(&fsCDVol);
};

//C^[tF[Xdl
/*
	ANZXw : virtual, public
	      ֐ : CDDA::Play(UInt32)
	        @\ : CD-DA t[`
	         : i  j      tJngbNԍ
	      ߂l : noErr  c I
				   ̑ c G[
	        O : 
	        l : 1. i  j͉̓\ő͈͂ 1 ` 99 ł
				   2. Mixed Mode CD ̏ꍇAJngbN 2 ł
*/
/*
	ANZXw : virtual, public
	      ֐ : CDDA::Pause(void)
	        @\ : CD-DA tꎞ~^ĊJ[`
	         : bPause       true c ꎞ~
				                   false c tĊJ
	      ߂l : 
	        O : 
	        l : 
*/
/*
	ANZXw : virtual, public
	      ֐ : CDDA::Stop(void)
	        @\ : CD-DA t~[`
	         : 
	      ߂l : 
	        O : 
	        l : 
*/
/*
	ANZXw : virtual, public
	      ֐ : CDDA::Task(void)
	        @\ : CD-DA t^XN
	         : 
	      ߂l : 
	        O : 
	        l : 1. t͒IɁi : 0.05 b  1 jĂяoƁB
*/
/*
	ANZXw : virtual, public
	      ֐ : CDDA::Volume(void)
	        @\ : CD ʂ𓾂
	         : 
	      ߂l : 
	        O : 
	        l : 1. Ԃʂ̒l͈̔͂ɋK͂ȂA 0 ` 255 łB
*/
/*
	ANZXw : virtual, public
	      ֐ : CDDA::Volume(UInt32)
	        @\ : CD ʂݒ肷
	         : i  j      CD 
	      ߂l : 
	        O : 
	        l : 1. i  j͉̓\͈͂ɋK͂ȂA 0 ` 255 łB
*/
/*
	ANZXw : virtual, public
	      ֐ : CDDA::AudioStatus(void)
	        @\ : CD tԂ𓾂
	         : 
	      ߂l : CD t
				       cdCtrlPlaying    c t
				       cdCtrlPaused     c tꎞ~
				       cdCtrlMuting     c ~[g
				       cdCtrlCompleted  c t
				       cdCtrlError      c G[
				       cdCtrlNotPlaying c t~
	        O : 
	        l : 
*/
/*
	ANZXw : virtual, public
	      ֐ : CDDA::PlayingInfo(UInt32*, MSFRecord*)
	        @\ : CD t𓾂
	         : i  j  o    tgbNԍ
				   i  j  o    ݂̉t
	      ߂l : noErr  c t
				   ̑ c tĂȂ
	        O : 
	        l : 1. ֐߂l noErr ̏ꍇAi  jɂ 1 ` 99 ͈͓̔̒lԂ
*/
/*
	ANZXw : virtual, public
	      ֐ : CDDA::Repeat(void)
	        @\ : JԂttO𓾂
	         : 
	      ߂l : JԂttO
	        O : 
	        l : 
*/
/*
	ANZXw : virtual, public
	      ֐ : CDDA::Repeat(bool)
	        @\ : JԂttOݒ肷
	         : i  j      JԂttO
	      ߂l : 
	        O : 
	        l : 
*/
/*
	ANZXw : virtual, public
	      ֐ : CDDA::MixedMode
	        @\ : MixedMode CD 肷
	         : 
	      ߂l :  true c MixedMode CD
				   false c Audio CD
	        O : 
	        l : MixedMode CD ̏ꍇAJngbN 2 ɂȂB
				   iȊȌꍇAJngbN 1j
*/
/*
	ANZXw : virtual, public
	      ֐ : CDDA::TrackCount
	        @\ : gbN𓾂
	         : 
	      ߂l : 1 ` 99 c gbN
				   0       c G[
	        O : 
	        l : 1. gbN̍ől 99 ł
*/

#endif	//__CDDA__