/*
	t@C : Framework.h
	e         : t[[N[h^A[h[`
	     : Mac OS 9.x : CarbonLib 1.2 ȍ~
				   Mac OS X   : PEF oCii CFM x[XjAvP[V
	l         : 1. Mach-O oCiAvP[Vł͕sv
				   2. Mac OS 9.x ̏ꍇACFM oCĩt[[N̂݃[h\
*/
#ifndef __FRAMEWORK__
#define __FRAMEWORK__

#ifndef __CARBON__
#include <Carbon.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
	      ֐ : LoadFramework
	        @\ : wfBNg̃t[[N[hB
	         : FS_PARENT_DIR_PTR      t[[Ni[ĂfBNgւ̎Q
				   strFrameworkName       t[[N
				   bundlePtr          o    t[[Nւ̎Q
	      ߂l : noErr    c I
				   paramErr c bundlePtr Ƀk|C^n
				   ̑   c G[
	        l : 1. ߂l noErr ȊȌꍇAbundlePtr wl NULL Ԃ
				   2. t[[NgṕAUnloadFramework ֐ŉ邱
*/
OSStatus										LoadFramework(const FSRef*	FS_PARENT_DIR_PTR,
															  CFStringRef	strFrameworkName,
															  CFBundleRef*	bundlePtr);

/*
	      ֐ : LoadSystemFramework
	        @\ : /System/Library/Frameworks ̃t[[N[hB
	         : strFrameworkName      t[[N
				   bundlePtr         o    t[[Nւ̎Q
	      ߂l : noErr    c I
				   paramErr c bundlePtr Ƀk|C^n
				   ̑   c G[
	        l : 1. ߂l noErr ȊȌꍇAbundlePtr wl NULL Ԃ
				   2. t[[NgṕAUnloadFramework ֐ŉ邱
*/
OSStatus										LoadSystemFramework(CFStringRef		strFrameworkName,
																	CFBundleRef*	bundlePtr);

/*
	      ֐ : GetFrameworkProcedureAddress
	        @\ : t[[N̎w֐ւ̊֐|C^𓾂
			 : bundleRef             t[[Nւ̎Q
				   strProcedureName      ֐
	      ߂l : w֐ւ̊֐|C^
	        l : 1. ֐̎sɎsꍇANULL |C^Ԃ
*/
#ifdef __cplusplus

inline void*									GetFrameworkProcedureAddress(CFBundleRef	bundleRef,
																			 CFStringRef	strProcedureName)
{
	return ::CFBundleGetFunctionPointerForName(bundleRef,
											   strProcedureName);
}

#else

#define GetFrameworkProcedureAddress(bundleRef, strProcedureName)	\
												CFBundleGetFunctionPointerForName(bundleRef, strProcedureName)

#endif

/*
	      ֐ : UnloadFramework
	        @\ : t[[NA[hB
	         : bundlePtr      t[[Nւ̎Q
				              o    k|C^
	      ߂l : 
	        l : 
*/
void											UnloadFramework(CFBundleRef*	bundlePtr);

#ifdef __cplusplus
}
#endif

#endif		/*__FRAMEWORK__*/