/*
	t@C : GSpLibrary.h
	e         : Carbon GameSprockets Cu[h^A[h[`
	     : Mac OS 9.x : CarbonLib 1.2 ȍ~
				   Mac OS X   : Mac OS X 10.0 ȍ~
	l         : 
*/
#ifndef __GSPLIBRARY__
#define __GSPLIBRARY__

#ifndef __CARBON__
#include <Carbon.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*^`*/
/*Cuւ̎Qƌ^iC^[tF[X͔Jj*/
typedef union _Library*							LibraryRef;


/*
	      ֐ : LoadGSpLibrary
	        @\ : GameSprockets Cu[h
	         : strLibName      GameSprockets Cu
				   connIDPtr   o    GameSprockets Cuւ̎Q
	      ߂l : noErr    : 
				   paramErr : strLibName, connIDPtr Ƀk|C^nꂽ
				   ̑   : G[
	        l : 1. GameSprockets CǔΏۂ́Aȉ̏ꏊł
				          EAvP[VƓKwi Mac OS 9.x j
				          E@\gtH_          i Mac OS 9.x j
				          E/System/Library/Frameworks/ tH_i Mac OS X j
				   2. gp UnloadGSpLibrary ֐ GameSprockets CuA[h邱
					  i[Nj
*/
OSStatus										LoadGSpLibrary(CFStringRef	strLibName,
															   LibraryRef*	libPtr);

/*
	      ֐ : GetGSpAPIAddress
	        @\ : GameSprockets w API ֐ւ̊֐|C^𓾂
	         : libRef           GameSprockets Cuւ̎Q
				   strProcName      API ֐
	      ߂l : w API ֐ւ̊֐|C^
	        l : 1. ֐̎sɎsꍇANULL |C^Ԃ
*/
ProcPtr											GetGSpAPIAddress(LibraryRef		libRef,
																 CFStringRef	strAPIName);

/*
	      ֐ : UnloadGSpLibrary
	        @\ : GameSprockets CuA[h
	         : libPtr      GameSprockets Cuւ̎Q
				           o    ȃCuւ̎Q
	      ߂l : 
	        l : 
*/
void											UnloadGSpLibrary(LibraryRef*	libPtr);


#ifdef __cplusplus
}
#endif


#endif	/*__GSPLIBRARY__*/