/*
	t@C : VersionUtility.c
	e         : [eBeBW[
	     : Mac OS 9.x : CarbonLib 1.0 ȍ~
				   Mac OS X   : Mac OS X 10.0 ȍ~
	l         : 
*/
#include "VersionUtilities.h"

/*[eBeBW[*/
/*
	      ֐ : GetSystemVersion
	        @\ : Mac OS ̃o[W𓾂
	         : 
	      ߂l : Mac OS ̃o[Wrbg
	               MacOS X 10.1.2 c 0x00001012
	               MacOS X 10.1.1 c 0x00001011
	               MacOS X 10.1   c 0x00001010
	               MacOS X 10.0.4 c 0x00001004
	               MacOS X 10.0   c 0x00001000
	               MacOS 9.2.2    c 0x00000922
	               MacOS 9.2.1    c 0x00000921
	               MacOS 9.1      c 0x00000910
	               MacOS 9.0.4    c 0x00000904
	               MacOS 9        c 0x00000900
	               MacOS 8.6      c 0x00000860
	               MacOS 8.5.1    c 0x00000851
	               MacOS 8.5      c 0x00000850
	               MacOS 8.1      c 0x00000810
	        l : 
*/
UInt32				GetSystemVersion(void)
{
	/*ϐ錾*/
	UInt32				ui32Ret = 0;	/*VXeo[W*/

	/**/
    Gestalt(gestaltSystemVersion,
			(SInt32*)(&ui32Ret));
	return ui32Ret;
}

/*
	      ֐ : GetCarbonVersion
	        @\ : CarbonLibi  Carbon.framework j̃o[W𓾂
	         : 
	      ߂l : CarbonLibi  Carbon.framework j̃o[Wrbg
				   Version 1.5   c 0x00000150
				   Version 1.4   c 0x00000140
				   Version 1.3.1 c 0x00000131
				   Version 1.2.5 c 0x00000125
				   Version 1.2   c 0x00000120
				   Version 1.1   c 0x00000110
				   Version 1.0.4 c 0x00000104
				   Version 1.0   c 0x00000100
	        l : 
*/
UInt32				GetCarbonVersion(void)
{
	/*ϐ錾*/
	UInt32				ui32Ret = 0;	/*Carbon o[W*/

	/**/
    Gestalt(gestaltCarbonVersion,
			(SInt32*)(&ui32Ret));
	return ui32Ret;
}

/*
	      ֐ : RunningMacOSX
	        @\ : AvP[V MacOS X œĂ邩
	         : 
	      ߂l :  TRUE c MacOS X
				   FALSE c ` MacOS 9.xi Classicj
	        l : 
*/
Boolean				RunningMacOSX(void)
{
	/**/
	return (Boolean)((GetSystemVersion() >= 0x00001000) ? TRUE : FALSE);
}

/*
	      ֐ : RunningClassic
	        @\ : AvP[V Classic ŋNĂ邩
	         : 
	      ߂l :  TRUE c Classic ŋN
				   FALSE c MacOS X lCeBu邢 ` MacOS 9.x ŋN
	        l : 
*/
Boolean											RunningClassic(void)
{
	/*ϐ錾*/
	UInt32											ui32Ret = 0;	/*Classic tO*/

	/**/
	Gestalt(gestaltMacOSCompatibilityBoxAttr, 
			(SInt32*)(&ui32Ret));
	return (Boolean)((0 != (ui32Ret & (1 << gestaltMacOSCompatibilityBoxPresent))) ? TRUE : FALSE);
}

/*
	      ֐ : RuntimeHash
	        @\ : sɉnbVl𓾂
	         : 
	      ߂l : sɉnbVl
				     0 : Mac OS 9.xi  Classic j
				     1 : Mac OS X
	        l : 
*/
UInt32 RuntimeHash(void)
{
    /*ϐ錾*/
    static const UInt32 kDefaultValue = 0xFFFFFFFF;
    static Boolean  bIsOSX        = FALSE;
    static Boolean  bIsClassic    = FALSE;
    static UInt32   ui32Ret       = 0xFFFFFFFF;

    /**/
    if(kDefaultValue == ui32Ret)
    {
        bIsOSX     = RunningMacOSX();
        bIsClassic = (Boolean)(bIsOSX ? RunningClassic() : TRUE);
        bIsOSX     = (Boolean)(bIsOSX ? !bIsClassic      : FALSE);
        
        if(TRUE == bIsClassic)
            ui32Ret = 0;
        if(TRUE == bIsOSX)
            ui32Ret = 1;
    }
    
    return ui32Ret;
}