/*=======================================================================
  AVG32-like scriptor for Macintosh
  Copyright 2000, K.Takagi(Kenjo)

  main.cpp
    C֐ECxgȂ

  ύX
      2002/01/14 : F.Shiraishi
				   TARGET_CARBON }N TARGET_API_MAC_CARBON }NɕύX

      2002/01/14 : F.Shiraishi
					Mac OS X ł̃tXN[ɑΉ
      					ύX֐
      						main
      					ύX@
      						a). AvP[V̋NAI DrawSprocket A
      						    ֐Ăяo悤C

=======================================================================*/

#include "system.h"
#include "debug.h"
#include "common.h"
#include "CFMDrawSprocket.h"

static WindowPtr	hWnd;
static SYSTEM*		sys;


#include <unistd.h>


static void setApplicationPath( const char *path )
{
    // /Users/..../Desktop/kurokoge2003/build/kurokoge2003.app/Contents/MacOS/kurokoge2003
    // argv[0]͂ȊB
    // Ƃ肠Ɍ납SĂ݂

    char *current = new char[2048];
    int length = strlen( path );
    int count = 0;

    if( length < 2048 )
        strcpy( current, path );
    else
        return;

    length--;
    while(true)
    {
        if( current[length] == '/' )
        {
            count++;

        }
        
        if( count >= 4 )
        {
            current[length] = '\0';
            break;
        }
        length--;
    }

    chdir( current );
    
    delete current;
}


//--------------------------------------------------------------------
// Initialize()
//   ь炨񑩂̏
//--------------------------------------------------------------------

static void Initialize(void)
{
	FlushEvents(everyEvent, 0);
	InitCursor();
}


void SetupQuitApplicaitonEvent(void);
pascal OSErr handleQuitApp(AppleEvent *event, AppleEvent *reply, long refcon);


//--------------------------------------------------------------------
// main()
//   ܁A񑩂
//--------------------------------------------------------------------

#include <stdio.h>

int main( int c, char *v[] )
{
	OSStatus	si32Err;

	hWnd = NULL;
	Initialize();

        // chdir
        setApplicationPath( v[0] );

	/*DrawSprocket ̏*/
	si32Err = DSpStartup();

	SetupQuitApplicaitonEvent();

	DebugStart();

	// Window쐬
	//hWnd = GetNewCWindow(128, NULL, (WindowPtr)-1);
	hWnd = MakeWindow640x480();

	// VXeIuWFNg쐬Ǝs
	if(hWnd)
	{
		SizeWindow(hWnd, 640, 480, true);
		ShowWindow(hWnd);
		sys = SYSTEM::Create(hWnd);
		if( sys )
		{
			sys->Init();
			sys->Reset();
			sys->EventLoop();
			delete sys;
		}
		else
		{
			Error("Could not make SYSTEM object.");
		}
		// EBhEƃIuWFNg폜ďI
		DisposeWindow(hWnd);
	}
	else
	{
		Error("Could not make the window.");
	}

	DebugEnd();

	/*DrawSprocket ̉*/
	si32Err = DSpShutdown();


    return 0;
}

/*
	Quit Application nh̓o^
*/
void SetupQuitApplicaitonEvent(void)
{
	AEInstallEventHandler(	kCoreEventClass,
							kAEQuitApplication,
							NewAEEventHandlerUPP((AEEventHandlerProcPtr)handleQuitApp),
							0L,
							false );
}

/*
	Quit Application nh
*/
pascal OSErr handleQuitApp(AppleEvent *event, AppleEvent *reply, long refcon)
{

#pragma unused (event, reply, refcon)
	if(sys)
		sys->Quit();
	return noErr;
}
