/*=======================================================================
  AVG32-like scriptor for Macintosh
  Copyright 2000, K.Takagi(Kenjo)

  soundwav.cpp
    TEh֘A

  ύX
      2001/11/15 : F.Shiraishi
				   TARGET_CARBON }N TARGET_API_MAC_CARBON }NɕύX
      2001/11/15 : F.Shiraishi
      			   Carbon łł̃RpCG[΍s
      					ύX֐
      						WAVFileCallBack
      						WAVCallBack
      						WAVEndCallBack
      						SOUNDWAV::SOUNDWAV
      						SOUNDWAV::~SOUNDWAV
      						SOUNDKOE::SOUNDKOE
      					ύX@
      						a). Carbon łŒ`Ȃ buf, head oy Carbon łł
      						    gpȂ\̂̎QƉӏQƂȂ悤ɏC
      						b). WAVFileCallBack, WAVCallBack ֐ Carbon łł͒`Ȃ悤ɏC
      						    iCarbon łł͎gpȂ߁j
      						c). NewSndCallBackProcPtr -> NewSndCallBackUPP
      						    i SOUNDWAV::SOUNDWAV, SOUNDKOE::SOUNDKOE j
      						d). DisposePtr            -> DisposeSndCallBackUPP
      						    i SOUNDWAV::~SOUNDWAV, SOUNDKOE::~SOUNDKOE j
      	
      2001/12/04 :	keta
      				LoopCheck()̃[NC
      				GetVolume()
      				SetVolume()
      				
      				ȏAsoundwav(carbon).cppڐA

	  2001/12/14 : F.Shiraishi
						::EnterMovies(), ::ExitMovies() ĂяoȂ悤ɏC
					ύX֐
						SOUNDWAV::SOUNDWAV
						SOUNDWAV::~SOUNDWAV
					ύX@
						SOUND NX̃RXgN^̐擪AfBXgN^̍ŌŌĂяo悤ɂ߁A
						SOUNDWAV NX̃RXgN^AfBXgN^ł
						::EnterMovies(), ::ExitMovies() ̌Ăяo폜

	  2001/12/14 : F.Shiraishi
						t̏ꍇ ::MoviesTask() Ăяo悤ɏC
						iCxgȂꍇAK̊֐Ă΂邩 ::MoviesTask()
						  ĂяôɍœKƔfj
					ύX֐
						SOUNDWAV::LoopCheck

	  2003/01/06 : tmkk
					Kanon/AIRpb`΍F
					 KOEWAVf[^^Cv̏ꍇɂKOEt@C̎w@ύX
					 ɔSOUNDKOE::Play()̈P

	  2003/09/01 : tmkk
					Kanon/AIRpb`΍F
					 Carbon̏ꍇWAVf[^^CvKOEt@CQuickTimeɓ悤ύX
					 ɔ.mp3, .wav.mp3KOEt@CĐ悤ύX
					 ύX֐ SOUNDKOE::Play()
=======================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "soundwav.h"
#include "common.h"
#include "debug.h"

#include "system.h"

static int LinearTableFlag = 0;
static short LinearTable[256];

inline bool CheckHeader(unsigned char* b, char* header)
{
	int i = 0;
	while(header[i]) {
		if ( (char)(b[i]) != header[i] ) return false;
		i++;
	}
	return true;
};


// U8bitf[^16bitPCMւ̕ϊe[u
inline void SetupLinearTable(void)
{
	short i, data;
	if ( !LinearTableFlag ) {
		for (i=-0x80; i<0x80; i++) {
			data = i*2*abs(i);
			LinearTable[i+0x80] = data;
		}
	}
};

/************************************************************************
  class SOUNDWAV
    WAVTEh֘A
************************************************************************/

// Little <-> Big Endian
static void Endian16BitBuffer (Ptr buf, unsigned long count)
{

}


static void Linear8BitBuffer (Ptr buf, unsigned long count)
{
	int i;
	unsigned char *olddata = &((unsigned char*)buf)[count-1];
	short *newdata = &((short*)buf)[count-1];
	for (i=0; i<count; i++) {
		*newdata = LinearTable[*olddata];
		olddata--;
		newdata--;
	}
}

static pascal void WAVEndCallBack(SndChannelPtr /*ch*/, SndCommand* cmd)
{
	WAVINFO* wav = (WAVINFO*)(cmd->param2);
	wav->playingflag = 0;
}


SOUNDWAV::SOUNDWAV(int l)
{
	OSErr err;

	hsnd = 0;
	sndcb = 0;
	
	memset(&wav, 0, sizeof(WAVINFO));
	memset(&wfile[0], 0, sizeof(WAVFILEINFO));
	memset(&wfile[1], 0, sizeof(WAVFILEINFO));

	linear = l;
	if ( l ) SetupLinearTable();

	

	sndcb = NewSndCallBackUPP(WAVEndCallBack);	// IR[obNɂȂ݂

	err = SndNewChannel(&hsnd, sampledSynth, initStereo+initNoInterp+initNoDrop, sndcb);
	if ( err!=noErr ) {
		hsnd = 0;
		Error("Cannot make SndChannel.");
	}
	/*
	You should use QuickTime to play sound files. 
	Open a sound file as a QuickTime movie and play the movie back.
	This approach supports newer audio formats (like wav and mp3).

	łB
	*/
	
	mWAV = NULL;
};


SOUNDWAV::~SOUNDWAV(void)
{
	Stop();

	
	if ( ioc ) DisposePtr((Ptr)ioc);
	
	if ( sndcb ) DisposeSndCallBackUPP(sndcb);

	if ( hsnd )
	{
		SndDisposeChannel(hsnd, true);
		hsnd = 0;
	}
};


void SOUNDWAV::Play( char *file, int loop, int cutsize )
{
	unsigned char f[256];

	Stop();
	//fprintf(stderr,"%s\n",file);
	strcpy((char*)&f[1], file);
	f[0] = strlen(file);
	
	FSSpec WAV;

	OSErr	err = noErr;
	short		movieRefNum, resID = 0;

	err = FSMakeFSSpec( 0, 0, f, &WAV );

	if( err != noErr )
		Play2( &WAV, loop, cutsize );
};


void SOUNDWAV::Play2( FSSpec *WAV, int loop, int cutsize )
{
	short resID,movieRefNum;
	OSErr err;

	err = OpenMovieFile( WAV, &movieRefNum, fsRdPerm );
	if (!err)
	{
		err = NewMovieFromFile
		(
			&mWAV,
			movieRefNum,
			&resID,
			NULL,
			newMovieActive,
			NULL
		);
	}
	
	CloseMovieFile(movieRefNum);
	
	if (err)
	{
		if (mWAV)
		{
			DisposeMovie(mWAV);
			mWAV = NULL;
		}
	}
	else
	{
		wav.loopflag = loop;
		SetMovieVolume(mWAV, kFullVolume);
		GoToBeginningOfMovie(mWAV);
		StartMovie(mWAV);
	}
};



void SOUNDWAV::Stop(void)
{
    if( mWAV != NULL )
    {
        StopMovie(mWAV);
        DisposeMovie(mWAV);
		
        mWAV = NULL;
    }
};


void SOUNDWAV::GetVolume(int* l, int* r)
{
	// 2001/12/04 by keta
	// ĐĂ
	if( mWAV != NULL )
		*l = *r = GetMovieVolume( mWAV );
	
	else
		*l = *r = 0;


};


void SOUNDWAV::SetVolume(int l, int r)
{
	// 2001/12/04 by keta
	// ĐĂ
	if( mWAV != NULL )
		SetMovieVolume( mWAV, l );

};


int SOUNDWAV::IsPlaying(void)
{
	return wav.playingflag;
}

#if TARGET_API_MAC_CARBON

void SOUNDWAV::LoopCheck(void)
{

//2001/12/14 폜 F.Shiraishi
/*	if( mWAV != NULL && IsMovieDone(mWAV))
	{*/
//폜
//2001/12/14 ǉ F.Shiraishi
	if(NULL != mWAV)
	{
		if(IsMovieDone(mWAV))
		{
//ǉ
			if( wav.loopflag == 1 )
			{
				GoToBeginningOfMovie(mWAV);
				StartMovie(mWAV);
			}
			else
			{
				// 2001/12/04 by keta
				// Jl`i[NCj
				Stop();
			}
//2001/12/14 ǉ F.Shiraishi
		}
		else
			::MoviesTask(mWAV,
						 0);
//ǉ
	}
}

#endif

/************************************************************************
  class SOUNDKOE
    KOE֘A
************************************************************************/

#define MAXKOETABLE 1024

// SOUNDKOEpR[obNBIsPlayingtO𗎂Ƃ̂ړI
static pascal void KOECallBack(SndChannelPtr /*ch*/, SndCommand* cmd)
{
	int* flag = (int*)(cmd->param2);
	*flag = 0;
}


SOUNDKOE::SOUNDKOE(int type, int l)
{
	OSErr err;
	extended80 extFreq;
	double freq = 44100;
	int i, n;

	dtox80(&freq, &extFreq);
	tableid = -1;
	table = 0;
	maxnum = 0;
	rate = 22050;
	koetype = type;
	linear = l;

	koebuf = 0;
	hsnd = 0;
	playflag = 0;
	sndcb = 0;

	memset(&head, 0, sizeof(ExtSoundHeader));
	head.encode = extSH;
	head.AIFFSampleRate = extFreq;
	head.numChannels = 1;
	head.sampleSize = 16;

	
//2001/11/15 ǉ F.Shiraishi
#if !TARGET_API_MAC_CARBON
//ǉI

	sndcb = NewSndCallBackProc(KOECallBack);
	
//2001/11/15 ǉ F.Shiraishi
#else

	sndcb = NewSndCallBackUPP(KOECallBack);
	
#endif
//ǉI
	
	
	mWAV = NULL;

	err = SndNewChannel(&hsnd, sampledSynth, 0/*initStereo+initNoInterp+initNoDrop*/, sndcb);
	if ( err!=noErr ) {
		hsnd = 0;
		Error("Cannot make SndChannel.");
	}

	SetupLinearTable();
	// ϊe[u쐬
	// table1 : 8bitTv -> 16bitTvϊ
	for (i=-128; i<128; i++) {
		table1[i+128] = (short)(i*0x100);			// $00`$FF -> -32768`+32767 EEEɂȂƎvi
	}
	// table2 : 4/8bit DifferencialPCM nibble? -> oCgf[^
	for (i=0; i<256; i++) {
		n = (i>>1);
		if ( i&1 ) n ^= 0xff;						// ŉʃrbgnibble̕L
		table2[i] = (256-n)&0xff;
//if ( i&1 ) n = -n;
//table2[i] = -n;
	}
}


SOUNDKOE::~SOUNDKOE(void)
{
	Stop();
	if ( table ) delete[] table;
	if ( hsnd ) {
		SndDisposeChannel(hsnd, true);
		hsnd = 0;
	}
	if ( koebuf ) delete[] koebuf;
	
//2001/11/15 ǉ F.Shiraishi
#if !TARGET_API_MAC_CARBON
//ǉI

	if ( sndcb ) DisposePtr((Ptr)sndcb);

//2001/11/15 ǉ F.Shiraishi
#else

	if ( sndcb ) DisposeSndCallBackUPP(sndcb);

#endif
//ǉI

}

void SOUNDKOE::MakeTable(char* f, int tid)
{
	FILE* fp = 0;
	unsigned char head[32];
	int i;

	// ̂ƂȂe[uȂ炻̂܂
	if ( tableid==tid ) return;

	if ( table ) delete[] table;
	tableid = -1;
	table = 0;
	maxnum = 0;

	fp = fopen(f, "rb");
	if ( fp ) {
		fread(head, 32, 1, fp);
		if ( !strcmp((char*)head, "KOEPAC") ) {
			maxnum = ((head[16])|(head[17]<<8)|(head[18]<<16)|(head[19]<<24));
			rate = ((head[24])|(head[25]<<8)|(head[26]<<16)|(head[27]<<24));
			if ( !rate ) rate = 22050;		// flowers, 0ƃftHgl݂
			if ( (maxnum>0)&&(maxnum<MAXKOETABLE) ) {
				table = new KOETABLE[maxnum+1];
				if ( table ) {
					fread((unsigned char*)table, maxnum<<3, 1, fp);
					Endian16BitBuffer((Ptr)table, maxnum<<3);
					for (i=0; i<maxnum; i++) {		// long̓GfBAύXł͑ΉłȂ̂
						table[i].pos = ((table[i].pos>>16)|((table[i].pos&0xffff)<<16));
					}
					tableid = tid;
					fseek(fp, 0, 2);
					table[maxnum].pos = ftell(fp);
					table[maxnum].symbol = 0;
					table[maxnum].id = 999999;		// ܁AŜ
				}
			}
		}
		fclose(fp);
	}
}


// oCgobt@ s[]  n Ԗڂ nibble 𓾂
// obt@e $AB $CD $EF ... ƂƁAn=0,1,2,3...̕Ԓl
// $0B $0A $0D $0C ... ƂȂ܂B
#define nibble(s,n) ((s[n>>1]>>((n&1)<<2))&15)


void SOUNDKOE::Play(char* f, int tid, int id, int name)
{
	int i, j, num;
	int srcsize = 0, dstsize = 0;
	unsigned short* buf = 0;
	unsigned char *srcbuf = 0, *src, s, data;
	signed short *dst = 0;
	FILE* fp = 0;
	SndCommand cmd;
	char file[1024];

	Stop();

	// TEhfoCXȂȂA
	if ( !hsnd ) return;
	
#if TARGET_API_MAC_CARBON
	char parent[1024];
	FSRef parentRef;
	ProcessSerialNumber  currentProcess = { 0, kCurrentProcess }; 
	GetProcessBundleLocation( &currentProcess, &parentRef); 
	CFURLRef urlAppDir = ::CFURLCreateFromFSRef(kCFAllocatorDefault,&parentRef);
	CFURLRef urlTmpDir = CFURLCreateCopyDeletingLastPathComponent(kCFAllocatorDefault,urlAppDir);
	CFURLGetFileSystemRepresentation(urlTmpDir,true,(UInt8 *)parent,1024);
	::CFRelease(urlAppDir);
	::CFRelease(urlTmpDir);
	
	if ( koetype ) {			// Differencial PCM / PAC ̎ (DOUBLE_PAC)
		// e[uǂݍ
		sprintf(file, "%s/%s/Z%03d.KOE",parent, f, tid);
		//fprintf(stderr,"%s\n",file);
		MakeTable(file, tid);
		if ( !table ) return;

		// e[u
		for (i=0; i<maxnum; i++) {
			if ( table[i].id==id ) break;		// ߁`
		}
		if ( i==maxnum ) return;				// ߂ȂEEE

		// V{Xgǂݍ
		num = table[i].symbol;
		buf = new unsigned short[num];
		fp = fopen(file, "rb");
		if ( (fp)&&(buf) ) {
			fseek(fp, table[i].pos, 0);
			fread((unsigned char*)buf, num, 2, fp);
			fclose(fp);
		} else {
			if ( fp ) fclose(fp);
			if ( buf ) delete[] buf;
			return;
		}

		// V{XgTCYvZ
		for (j=0; j<num; j++) {
			buf[j] = ((buf[j]>>8)|((buf[j]&0xff)<<8));		// Endianւ񂱁[
			srcsize += buf[j];
			if ( buf[j] ) {
				if ( buf[j]==0x400 )
					dstsize += 0x400;			// $400͂̂܂܃Rs[Ȃ̂
				else
					dstsize += (buf[j]<<1);		// $001`$3FFAő2{ɑ
			} else {
				dstsize += 0x400;				// ^H
			}
		}

		// TCY`FbN
		if ( srcsize>(table[i+1].pos-table[i].pos) ) return;	// TCY

		// [ǂݍށTvOobt@p
		srcbuf = new unsigned char[srcsize];
		if ( srcbuf ) {
			fp = fopen(file, "rb");
			if ( !fp ) {
				delete[] srcbuf;
				return;
			}
			fseek(fp, table[i].pos+num*2, 0);
			fread(srcbuf, srcsize, 1, fp);
			fclose(fp);
			koebuf = new signed short[dstsize];
			if ( !koebuf ) {
				delete[] srcbuf;
				return;
			}
		}

		// ł[ǂ
		src = srcbuf;
		dst = koebuf;
		for (i=0; i<num; i++) {
			if ( buf[i] ) {
				if ( buf[i]==0x400 ) {
					for (j=0; j<0x400; j++) {
//						*dst++ = table1[*src++];
*dst++ = LinearTable[*src++];
					}
				} else {
					data = 0;
					for (j=0; j<buf[i]*2; ) {
						s = nibble(src,j);					// ܂1nibbleE
						j++;
						if ( s==15 ) {						// nibble15̎2oCg
							s = nibble(src,j);				// nibble2E
							j++;
							s |= (nibble(src,j)<<4);
							j++;
						}
						data += table2[s&255];				// 8bitTvOf[^ɉZ
//						*dst++ = table1[data&255];			// 16rbgɕϊ
*dst++ = LinearTable[data&255];
					}
					src += buf[i];
				}
			} else {					// ^H
				for (j=0; j<0x400; j++) {
					*dst++ = 0;
				}
			}
		}
		delete[] srcbuf;
		dstsize = dst-koebuf;
		
		// ĐJn`
		head.sampleRate = (rate<<16);
		head.numFrames = dstsize;
		head.samplePtr = (Ptr)koebuf;
		cmd.cmd = bufferCmd;
		cmd.param1 = 0;
		cmd.param2 = (long)(&head);
		SndDoCommand(hsnd, &cmd, true);
		playflag = 1;
		cmd.cmd = callBackCmd;
		cmd.param1 = 0;
		cmd.param2 = (long)(&playflag);
		SndDoCommand(hsnd, &cmd, true);
		
	} else {			// WAVf[^^Cv̏ꍇiLinearw̏ĂȂEEEj
		sprintf(file, "%s/%s/%d/Z%d.WAV",parent, f, tid, name);
		fp = fopen(file, "rb");
		if(!fp) {
			sprintf(file, "%s/%s/%d/Z%d.MP3",parent, f, tid, name);
			fp = fopen(file, "rb");
		}
		if(!fp) {
			sprintf(file, "%s/%s/%d/Z%d.WAV.MP3",parent, f, tid, name);
			fp = fopen(file, "rb");
		}
		if ( fp ) {
			fclose(fp);
			FSSpec WAV;
			
			OSErr	err = noErr;
			short		movieRefNum, resID = 0;
			
			Boolean isDirectory;
			FSRef tmpRef;
			err = FSPathMakeRef((UInt8 *)file, &tmpRef, &isDirectory);
			err = FSGetCatalogInfo(&tmpRef, kFSCatInfoNone, NULL, NULL, &WAV, NULL);
			
			err = OpenMovieFile( &WAV, &movieRefNum, fsRdPerm );
			if (!err)
			{
				err = NewMovieFromFile(	&mWAV,
							movieRefNum,
							&resID,
							NULL,
							newMovieActive,
							NULL );
			}
			
			CloseMovieFile(movieRefNum);
			if (err)
			{
				if (mWAV)
				{
					DisposeMovie(mWAV);
					mWAV = NULL;
				}
			}
			else
			{
				SetMovieVolume(mWAV, kFullVolume);
				GoToBeginningOfMovie(mWAV);
				StartMovie(mWAV);
				playflag = 1;
			}
		} else {
			return;
		}
	}
#else
	
	if ( koetype ) {			// Differencial PCM / PAC ̎ (DOUBLE_PAC)
		// e[uǂݍ
		sprintf(file, ":%s:Z%03d.KOE", f, tid);
		MakeTable(file, tid);
		if ( !table ) return;

		// e[u
		for (i=0; i<maxnum; i++) {
			if ( table[i].id==id ) break;		// ߁`
		}
		if ( i==maxnum ) return;				// ߂ȂEEE

		// V{Xgǂݍ
		num = table[i].symbol;
		buf = new unsigned short[num];
		fp = fopen(file, "rb");
		if ( (fp)&&(buf) ) {
			fseek(fp, table[i].pos, 0);
			fread((unsigned char*)buf, num, 2, fp);
			fclose(fp);
		} else {
			if ( fp ) fclose(fp);
			if ( buf ) delete[] buf;
			return;
		}

		// V{XgTCYvZ
		for (j=0; j<num; j++) {
			buf[j] = ((buf[j]>>8)|((buf[j]&0xff)<<8));		// Endianւ񂱁[
			srcsize += buf[j];
			if ( buf[j] ) {
				if ( buf[j]==0x400 )
					dstsize += 0x400;			// $400͂̂܂܃Rs[Ȃ̂
				else
					dstsize += (buf[j]<<1);		// $001`$3FFAő2{ɑ
			} else {
				dstsize += 0x400;				// ^H
			}
		}

		// TCY`FbN
		if ( srcsize>(table[i+1].pos-table[i].pos) ) return;	// TCY

		// [ǂݍށTvOobt@p
		srcbuf = new unsigned char[srcsize];
		if ( srcbuf ) {
			fp = fopen(file, "rb");
			if ( !fp ) {
				delete[] srcbuf;
				return;
			}
			fseek(fp, table[i].pos+num*2, 0);
			fread(srcbuf, srcsize, 1, fp);
			fclose(fp);
			koebuf = new signed short[dstsize];
			if ( !koebuf ) {
				delete[] srcbuf;
				return;
			}
		}

		// ł[ǂ
		src = srcbuf;
		dst = koebuf;
		for (i=0; i<num; i++) {
			if ( buf[i] ) {
				if ( buf[i]==0x400 ) {
					for (j=0; j<0x400; j++) {
//						*dst++ = table1[*src++];
*dst++ = LinearTable[*src++];
					}
				} else {
					data = 0;
					for (j=0; j<buf[i]*2; ) {
						s = nibble(src,j);					// ܂1nibbleE
						j++;
						if ( s==15 ) {						// nibble15̎2oCg
							s = nibble(src,j);				// nibble2E
							j++;
							s |= (nibble(src,j)<<4);
							j++;
						}
						data += table2[s&255];				// 8bitTvOf[^ɉZ
//						*dst++ = table1[data&255];			// 16rbgɕϊ
*dst++ = LinearTable[data&255];
					}
					src += buf[i];
				}
			} else {					// ^H
				for (j=0; j<0x400; j++) {
					*dst++ = 0;
				}
			}
		}
		delete[] srcbuf;
		dstsize = dst-koebuf;
	} else {			// WAVf[^^Cv̏ꍇiLinearw̏ĂȂEEEj
		sprintf(file, ":%s:%d:Z%d.WAV", f, tid, name);
		fp = fopen(file, "rb");
		if ( fp ) {
			fread(header, 128, 1, fp);
			for (i=36; i<128; i+=2) {
				if ( CheckHeader(&header[i], "data") ) {
					num = i+8;
					srcsize = ((header[i+4])|(header[i+5]<<8)|(header[i+6]<<16)|(header[i+7]<<24));
					srcsize -= num;
					break;
				}
			}
			srcbuf = new unsigned char[srcsize+4];			// +4  Endian16BitBuffer  4 oCgPʂŌvZ邽
			if ( (CheckHeader(header, "RIFF")) &&			// ̕ӂ͌ߑł
				 (CheckHeader(&header[8], "WAVE")) &&
				 (CheckHeader(&header[12], "fmt")) &&
				 (srcsize>4) &&
				 (srcbuf) ) {
				fseek(fp, num, 0);
				fread(srcbuf, srcsize, 1, fp);
				fclose(fp);
				rate = ((header[24])|(header[25]<<8)|(header[26]<<16)|(header[27]<<24));
				head.numChannels = ((header[22])|(header[23]<<8));
				head.sampleSize = ((header[34])|(header[35]<<8));
				dstsize = (srcsize/(head.numChannels*head.sampleSize/8));
				if ( head.sampleSize==16 ) Endian16BitBuffer((Ptr)srcbuf, srcsize);
				koebuf = (short*)srcbuf;
			} else {
				fclose(fp);
				return;
			}
		} else {
			return;
		}
	}

	// ĐJn`
	head.sampleRate = (rate<<16);
	head.numFrames = dstsize;
	head.samplePtr = (Ptr)koebuf;
	cmd.cmd = bufferCmd;
	cmd.param1 = 0;
	cmd.param2 = (long)(&head);
	SndDoCommand(hsnd, &cmd, true);
	playflag = 1;
	cmd.cmd = callBackCmd;
	cmd.param1 = 0;
	cmd.param2 = (long)(&playflag);
	SndDoCommand(hsnd, &cmd, true);
	
#endif
}


void SOUNDKOE::Stop(void)
{
	SndCommand cmd;
	
	playflag = 0;
	
	if ( koetype ) {
		if ( hsnd ) {
			cmd.param1 = 0;
			cmd.param2 = 0;
			cmd.cmd = quietCmd;
			SndDoImmediate(hsnd, &cmd);
			cmd.cmd = flushCmd;
			SndDoImmediate(hsnd, &cmd);
		}
		if ( koebuf ) {
			delete[] koebuf;
			koebuf = 0;
		}
	}
	else {
		if( mWAV != NULL )
		{
			StopMovie(mWAV);
			DisposeMovie(mWAV);
			
			mWAV = NULL;
		}
	}
}


int SOUNDKOE::IsPlaying(void)
{
	return playflag;
}
