/*
	t@C : CDHashMap.cpp
	e         : CD-DA ։pnbV\
	     : Mac OS 9.x c Mac OS 8.6 ȍ~ + CarbonLib 1.0 ȍ~
	               Mac OS X   c Mac OS X 10.1 ȍ~
	l         : 1. Audio CD }EgĂȂꍇA
	                  ։̌Ɏgp
*/
#include "CDHashMap.h"

//static o萔̏
const UInt32				CDHashMap::kTmplCount                        = 16;
const char*					CDHashMap::kTrackTmpl[CDHashMap::kTmplCount] = {"%d",
																			"%02d",
																			"%02d.mp3",
																			"%02d.wav",
																			"%02d.wave",
																			"%02d.m4a",
																			"%02d.aif",
																			"%02d.aiff",
																			"Track %02d",
																			"Track %02d.mp3" ,
																			"Track %02d.cdda",
																			"Track %02d.aiff",
																			"Track %02d.wave",
																			"Track %02d.aif" ,
																			"Track %02d.wav" ,
																			"Track %02d.m4a" };

/*
	ANZXw : public
	      ֐ : CDHashMap::CDHashMap
	        @\ : ։pnbV\̃RXgN^
	         : ui32MaxTrackNo      gbNԍ̍ől
	               aryTmpls            gbN̂i[ꂽ CFArrayi zvf CFString j
	                                       ւ̎QƁiȗ\j
	        O : std::bad_alloci Ɏsꍇ j
	        l : 
*/
							CDHashMap::CDHashMap(UInt32		ui32MaxTrackNo,
												 CFArrayRef	aryTrackTmpls) throw(std::bad_alloc) : 
							maxTrackNo_(0),
							trackMap_(NULL)
{
	//ϐ錾
	CFIndex						si32TmplCount;
	CFIndex						si32TmplsSize;
	CFStringRef*				strTmpls      = NULL;
	CFArrayRef					aryTmpls      = aryTrackTmpls;
	CFIndex						i;

	//p[^
	if(0 == ui32MaxTrackNo)
		throw std::bad_alloc();

	//
	try
	{
		///nbV\̃ev[gz쐬
		if(NULL == aryTrackTmpls)
		{
			si32TmplCount = static_cast<CFIndex>(CDHashMap::kTmplCount);
			si32TmplsSize = static_cast<CFIndex>(si32TmplCount * sizeof(CFStringRef));
			strTmpls      = static_cast<CFStringRef*>(::CFAllocatorAllocate(kCFAllocatorDefault,
																			si32TmplsSize,
																			0));
			if(NULL == strTmpls)
				throw std::bad_alloc();
			::BlockZero(strTmpls,
						si32TmplsSize);
			for(i = 0; i < si32TmplCount; i++)
			{
				strTmpls[i] = ::CFStringCreateWithCString(kCFAllocatorDefault,
														  CDHashMap::kTrackTmpl[i],
														  ::CFStringGetSystemEncoding());
				if(NULL == strTmpls[i])
					throw std::bad_alloc();
			}
			aryTmpls = ::CFArrayCreate(kCFAllocatorDefault,
									   reinterpret_cast<const void**>(strTmpls),
									   si32TmplCount,
									   &kCFTypeArrayCallBacks);
			if(NULL == aryTmpls)
				throw std::bad_alloc();
		}
		///nbV\쐬
		trackMap_   = CDHashMap::Init(ui32MaxTrackNo,
									  aryTmpls);
		maxTrackNo_ = ui32MaxTrackNo;
		///̈̉
		if(NULL == aryTrackTmpls)
		{
			::CFRelease(aryTmpls);
			for(i = 0; i < si32TmplCount; i++)
			{
				if(NULL != strTmpls[i])
					::CFRelease(strTmpls[i]);
			}
			::CFAllocatorDeallocate(kCFAllocatorDefault,
									strTmpls);
		}
	}
	catch(...)
	{
		///̈̊mۂɎsꍇ
		////̈̉
		if(NULL == aryTrackTmpls)
		{
			if(NULL != aryTmpls)
				::CFRelease(aryTmpls);
			if(NULL != strTmpls)
			{
				for(i = 0; i < si32TmplCount; i++)
				{
					if(NULL != strTmpls[i])
						::CFRelease(strTmpls[i]);
				}
				::CFAllocatorDeallocate(kCFAllocatorDefault,
										strTmpls);
			}
		}
		////Ô܂ܓ
		throw;
	}
}

/*
	ANZXw : private
	      ֐ : CDHashMap::CDHashMap
	        @\ : ։pnbV\̃RXgN^
	         : ui32SrcMaxTrackNo      ։pnbV\FgbNԍ̍ől
	               dicSrcMap              ։pnbV\
	        O : std::bad_alloci ̍쐬Ɏsꍇ j
	        l : CDHashMap::Clone() ֐Ŏgp
*/
							CDHashMap::CDHashMap(UInt32				ui32SrcMaxTrackNo,
												 CFDictionaryRef	dicSrcMap) throw(std::bad_alloc) : 
							maxTrackNo_(0),
							trackMap_(NULL)
{
	trackMap_   = ::CFDictionaryCreateCopy(kCFAllocatorDefault,
										   dicSrcMap);
	if(NULL == trackMap_)
		throw std::bad_alloc();
	maxTrackNo_ = ui32SrcMaxTrackNo;
}

/*
	ANZXw : virtual, public
	      ֐ : CDHashMap::~CDHashMap
	        @\ : ։pnbV\̃fXgN^
	         : 
	        O : 
	        l : 
*/
							CDHashMap::~CDHashMap(void) throw()
{
	//
	Dispose();
}

/*
	ANZXw : public, const
	      ֐ : CDHashMap::itemIfExists
	        @\ : Azzvf𓾂
	         : strKey            ։t@C
	               ui32ValueRef  o    ։t@ĈɑΉgbNԍ
	      ߂l : true  c ։t@ĈɑΉgbNԍ݂͑
	               false c ։t@ĈɑΉgbNԍ݂͑Ȃ
	        O : 
	        l : 
*/
bool						CDHashMap::itemIfExists(CFStringRef	strKey,
													UInt32&		ui32ValueRef) const throw()
{
	//ϐ錾
	bool						bRet      = false;
	CFNumberRef					nValue;
	Boolean						blnRet;
	CFIndex						si32Value;

	//p[^
	if(NULL == trackMap_)
		return bRet;
	if(NULL == strKey)
		return bRet;

	//
	nValue = static_cast<CFNumberRef>(::CFDictionaryGetValue(trackMap_,
															 strKey));
	bRet = (NULL != nValue);
	if(bRet)
	{
		blnRet = ::CFNumberGetValue(nValue,
									kCFNumberMaxType,
									&si32Value);
		bRet   = (FALSE != blnRet);
	}
	if(bRet)
		ui32ValueRef = static_cast<UInt32>(si32Value);
	return bRet;
}

/*
	ANZXw : private, const
	      ֐ : CDHashMap::Init
	        @\ : ։pnbV\̏֐
	         : ui32MaxTrackNo      gbNԍ̍ől
	        O : std::bad_alloci Ɏsꍇ j
	        l : 
*/
void						CDHashMap::Initialize(const CDHashMap&	OBJ_SRC_REF) throw()
{
	//
	if(NULL != OBJ_SRC_REF.trackMap_)
	{
		maxTrackNo_ = 0;
		trackMap_   = static_cast<CFDictionaryRef>(::CFRetain(OBJ_SRC_REF.trackMap_));
	}
}

/*
	ANZXw : private, const
	      ֐ : CDHashMap::Dispose
	        @\ : ։pnbV\̏֐
	         : ui32MaxTrackNo      gbNԍ̍ől
	        O : std::bad_alloci Ɏsꍇ j
	        l : 
*/
void						CDHashMap::Dispose(void) throw()
{
	///oϐ̉
	maxTrackNo_ = 0;
	if(NULL != trackMap_)
	{
		::CFRelease(trackMap_);
		trackMap_ = NULL;
	}
}

/*
	ANZXw : static, private
	      ֐ : CDHashMap::Init
	        @\ : ։pnbV\쐬֐
	         : ui32MaxTrackNo      gbNԍ̍ől
	               aryTmpls            gbÑev[gi[ꂽ
	                                       CFArrayi zvf CFString jւ̎Q
	      ߂l : ։pnbV\ւ̎Q
	        O : std::bad_alloci nbV\쐬Ɏsꍇ j
	        l : 
*/
CFDictionaryRef				CDHashMap::Init(UInt32		ui32MaxTrackNo,
											CFArrayRef	aryTmpls) throw(std::bad_alloc)
{
	//ϐ錾
	CFIndex						si32TmplCount;
	CFIndex						si32Count;
	CFIndex						si32Size;
	CFStringRef					strTmpl       = NULL;
	CFStringRef*				strKeys       = NULL;
	CFNumberRef*				nValues       = NULL;
	CFDictionaryRef				dicRet        = NULL;
	CFIndex						i;
	CFIndex						j;
	CFIndex						k;

	//p[^
	if(0    == ui32MaxTrackNo)
		throw std::bad_alloc();
	if(NULL == aryTmpls)
		throw std::bad_alloc();

	//
	try
	{
		///nbV\̃ev[gz擾
		si32TmplCount = ::CFArrayGetCount(aryTmpls);
		if(0 == si32TmplCount)
			throw std::bad_alloc();
		///nbV\i[f[^쐬
		si32Count = static_cast<CFIndex>(static_cast<UInt32>(si32TmplCount) * ui32MaxTrackNo);
		si32Size  = static_cast<CFIndex>(si32Count * sizeof(CFStringRef));
		strKeys   = static_cast<CFStringRef*>(::CFAllocatorAllocate(kCFAllocatorDefault,
																	si32Size,
																	0));
		if(NULL == strKeys)
			throw std::bad_alloc();
		::BlockZero(strKeys,
					si32Size);
		si32Size  = static_cast<CFIndex>(si32Count * sizeof(CFNumberRef));
		nValues   = static_cast<CFNumberRef*>(::CFAllocatorAllocate(kCFAllocatorDefault,
																	si32Size,
																	0));
		if(NULL == nValues)
			throw std::bad_alloc();
		::BlockZero(nValues,
					si32Size);
		for(i = 0, k = 0; i < si32TmplCount; i++)
		{
			strTmpl = static_cast<CFStringRef>(::CFArrayGetValueAtIndex(aryTmpls,
																		i));
			for(j = 0; j < static_cast<CFIndex>(ui32MaxTrackNo); j++, k++)
			{
				strKeys[k] = ::CFStringCreateWithFormat(kCFAllocatorDefault,
														NULL,
														strTmpl,
														j);
				nValues[k] = ::CFNumberCreate(kCFAllocatorDefault,
											  kCFNumberMaxType,
											  &j); 
				if(NULL == strKeys[k])
					throw std::bad_alloc();
				if(NULL == nValues[k])
					throw std::bad_alloc();
			}
		}
		///nbV\쐬
		dicRet = ::CFDictionaryCreate(kCFAllocatorDefault,
									  reinterpret_cast<const void**>(strKeys),
									  reinterpret_cast<const void**>(nValues),
									  si32Count,
									  &kCFTypeDictionaryKeyCallBacks,
									  &kCFTypeDictionaryValueCallBacks);
		if(NULL == dicRet)
			throw std::bad_alloc();
		///̈̉
		for(i = 0; i < si32Count; i++)
		{
			if(NULL != nValues[i])
				::CFRelease(nValues[i]);
		}
		::CFAllocatorDeallocate(kCFAllocatorDefault,
								nValues);
		for(i = 0; i < si32Count; i++)
		{
			if(NULL != strKeys[i])
				::CFRelease(strKeys[i]);
		}
		::CFAllocatorDeallocate(kCFAllocatorDefault,
								strKeys);
	}
	catch(...)
	{
		///̈̊mۂɎsꍇ
		////̈̉
		if(NULL != nValues)
		{
			for(i = 0; i < si32Count; i++)
			{
				if(NULL != nValues[i])
					::CFRelease(nValues[i]);
			}
			::CFAllocatorDeallocate(kCFAllocatorDefault,
									nValues);
		}
		if(NULL != strKeys)
		{
			for(i = 0; i < si32Count; i++)
			{
				if(NULL != strKeys[i])
					::CFRelease(strKeys[i]);
			}
			::CFAllocatorDeallocate(kCFAllocatorDefault,
									strKeys);
		}
		////Ô܂ܓ
		throw;
	}
	return dicRet;
}