/*
	t@C : CFMDrawSprocket.c
	e         : Mac OS 9.x / Mac OS X p CFMi PEF oCi jAvP[Vp
				   Carbon DrawSprocket API
	     : Mac OS 9.x : DrawSprocket Version 1.0  ȍ~i : DrawSprocket Version 1.7  ȍ~j
				                CarbonLib 1.2 ȍ~
				   Mac OS X   : DrawSprocket Version 1.9.9 ȍ~i Mac OS X 10.0.3 ȍ~ j
				                CFMi PEF oCi jAvP[V
	l         : 1. Mach-O oCiAvP[Vł͕sv
				   2. Mac OS 9.x ł DrawSprocketLib ̃o[WɂĎgps̊֐݂
*/
#if TARGET_API_MAC_CARBON && TARGET_RT_MAC_CFM

#include "CFMDrawSprocket.h"
#include "VersionUtilities.h"
#include "GSpLibrary.h"

/*^`*/
/*DSpCallbackUPP ֐|C^*/
typedef DSpCallbackUPP							(*NewDSpCallbackUPPProcPtr)(DSpCallbackProcPtr);
typedef void									(*DisposeDSpCallbackUPPProcPtr)(DSpCallbackUPP);
typedef Boolean									(*InvokeDSpCallbackUPPProcPtr)(DSpContextReference,
																			   void*,
																			   DSpCallbackUPP);

/*DSp IuWFNg֐|C^*/
typedef OSStatus								(*DSpStartupProcPtr)(void);
typedef OSStatus								(*DSpShutdownProcPtr)(void);
typedef NumVersion								(*DSpGetVersionProcPtr)(void);
typedef OSStatus								(*DSpGetMouseProcPtr)(Point*);
typedef OSStatus								(*DSpGetCurrentContextProcPtr)(DisplayIDType,
																			   DSpContextReference*);
typedef OSStatus								(*DSpGetFirstContextProcPtr)(DisplayIDType,
																			 DSpContextReference*);
typedef OSStatus								(*DSpGetNextContextProcPtr)(DSpContextReference,
																			DSpContextReference*);
typedef OSStatus								(*DSpSetDebugModeProcPtr)(Boolean);
typedef OSStatus								(*DSpSetBlankingColorProcPtr)(const RGBColor*);
typedef OSStatus								(*DSpProcessEventProcPtr)(EventRecord*,
																		  Boolean*);
typedef OSStatus								(*DSpFindContextFromPointProcPtr)(Point,
																				  DSpContextReference*);
typedef OSStatus								(*DSpFindBestContextProcPtr)(DSpContextAttributesPtr,
																			 DSpContextReference*);
typedef OSStatus								(*DSpFindBestContextOnDisplayIDProcPtr)(DSpContextAttributesPtr,
																						DSpContextReference*,
																						DisplayIDType);

/*DSpContext IuWFNg֐|C^*/
typedef OSStatus								(*DSpContext_ReleaseProcPtr)(DSpContextReference);
typedef OSStatus								(*DSpContext_DisposeProcPtr)(DSpContextReference);
typedef OSStatus								(*DSpContext_GetMonitorFrequencyProcPtr)(DSpContextReferenceConst,
																						 Fixed*);
typedef OSStatus								(*DSpContext_GetAttributesProcPtr)(DSpContextReferenceConst,
																				   DSpContextAttributesPtr);
typedef OSStatus								(*DSpContext_ReserveProcPtr)(DSpContextReference,
																			 DSpContextAttributesPtr);
typedef OSStatus								(*DSpContext_GetCLUTEntriesProcPtr)(DSpContextReferenceConst,
																					ColorSpec*,
																					UInt16,
																					UInt16);
typedef OSStatus								(*DSpContext_SetCLUTEntriesProcPtr)(DSpContextReference,
																					const ColorSpec*,
																					UInt16,
																					UInt16);
typedef OSStatus								(*DSpContext_GetStateProcPtr)(DSpContextReferenceConst,
																			  DSpContextState*);
typedef OSStatus								(*DSpContext_SetStateProcPtr)(DSpContextReference,
																			  DSpContextState);
typedef OSStatus								(*DSpContext_IsBusyProcPtr)(DSpContextReference,
																			Boolean*);
typedef OSStatus								(*DSpContext_GetDisplayIDProcPtr)(DSpContextReferenceConst,
																				  DisplayIDType*);
typedef OSStatus								(*DSpContext_GetFrontBufferProcPtr)(DSpContextReferenceConst,
																					CGrafPtr*);
typedef OSStatus								(*DSpContext_GetBackBufferProcPtr)(DSpContextReference,
																				   DSpBufferKind,
																				   CGrafPtr*);
typedef OSStatus								(*DSpContext_GlobalToLocalProcPtr)(DSpContextReference,
																				   Point*);
typedef OSStatus								(*DSpContext_LocalToGlobalProcPtr)(DSpContextReference,
																				   Point*);
typedef OSStatus								(*DSpContext_FadeGammaInProcPtr)(DSpContextReference,
																				 RGBColor*);
typedef OSStatus								(*DSpContext_FadeGammaOutProcPtr)(DSpContextReference,
																				  RGBColor*);
typedef OSStatus								(*DSpContext_FadeGammaProcPtr)(DSpContextReference,
																			   SInt32,
																			   RGBColor*);
typedef OSStatus								(*DSpContext_QueueProcPtr)(DSpContextReference,
																		   DSpContextReference,
																		   DSpContextAttributesPtr);
typedef OSStatus								(*DSpContext_SwitchProcPtr)(DSpContextReference,
																			DSpContextReference);
typedef OSStatus								(*DSpContext_SwapBuffersProcPtr)(DSpContextReference,
																				 DSpCallbackUPP,
																				 void*);

/*static ϐ錾*/
/*Cuւ̎Q*/
static Boolean									bInit                           = FALSE;
static LibraryRef								lib;

/*API ւ̊֐|C^*/
/*DSpCallbackUPP C^[tF[X*/
static NewDSpCallbackUPPProcPtr					tNewDSpCallbackUPP              = NULL;
static DisposeDSpCallbackUPPProcPtr				tDisposeDSpCallbackUPP          = NULL;
static InvokeDSpCallbackUPPProcPtr				tInvokeDSpCallbackUPP           = NULL;
/*DSp IuWFNgC^[tF[X*/
static DSpStartupProcPtr						tDSpStartup                     = NULL;
static DSpShutdownProcPtr						tDSpShutdown                    = NULL;
static DSpGetVersionProcPtr						tDSpGetVersion                  = NULL;
static DSpGetMouseProcPtr						tDSpGetMouse                    = NULL;
static DSpGetCurrentContextProcPtr				tDSpGetCurrentContext           = NULL;
static DSpGetFirstContextProcPtr				tDSpGetFirstContext             = NULL;
static DSpGetNextContextProcPtr					tDSpGetNextContext              = NULL;
static DSpSetDebugModeProcPtr					tDSpSetDebugMode                = NULL;
static DSpSetBlankingColorProcPtr				tDSpSetBlankingColor            = NULL;
static DSpProcessEventProcPtr					tDSpProcessEvent                = NULL;
static DSpFindContextFromPointProcPtr			tDSpFindContextFromPoint        = NULL;
static DSpFindBestContextProcPtr				tDSpFindBestContext             = NULL;
static DSpFindBestContextOnDisplayIDProcPtr		tDSpFindBestContextOnDisplayID  = NULL;
/*DSpContext IuWFNgC^[tF[X*/
static DSpContext_ReleaseProcPtr				tDSpContext_Release             = NULL;
static DSpContext_DisposeProcPtr				tDSpContext_Dispose             = NULL;
static DSpContext_GetMonitorFrequencyProcPtr	tDSpContext_GetMonitorFrequency = NULL;
static DSpContext_GetAttributesProcPtr			tDSpContext_GetAttributes       = NULL;
static DSpContext_ReserveProcPtr				tDSpContext_Reserve             = NULL;
static DSpContext_GetCLUTEntriesProcPtr			tDSpContext_GetCLUTEntries      = NULL;
static DSpContext_SetCLUTEntriesProcPtr			tDSpContext_SetCLUTEntries      = NULL;
static DSpContext_GetStateProcPtr				tDSpContext_GetState            = NULL;
static DSpContext_SetStateProcPtr				tDSpContext_SetState            = NULL;
static DSpContext_IsBusyProcPtr					tDSpContext_IsBusy              = NULL;
static DSpContext_GetDisplayIDProcPtr			tDSpContext_GetDisplayID        = NULL;
static DSpContext_GetFrontBufferProcPtr			tDSpContext_GetFrontBuffer      = NULL;
static DSpContext_GetBackBufferProcPtr			tDSpContext_GetBackBuffer       = NULL;
static DSpContext_GlobalToLocalProcPtr			tDSpContext_GlobalToLocal       = NULL;
static DSpContext_LocalToGlobalProcPtr			tDSpContext_LocalToGlobal       = NULL;
static DSpContext_FadeGammaInProcPtr			tDSpContext_FadeGammaIn         = NULL;
static DSpContext_FadeGammaOutProcPtr			tDSpContext_FadeGammaOut        = NULL;
static DSpContext_FadeGammaProcPtr				tDSpContext_FadeGamma           = NULL;
static DSpContext_QueueProcPtr					tDSpContext_Queue               = NULL;
static DSpContext_SwitchProcPtr					tDSpContext_Switch              = NULL;
static DSpContext_SwapBuffersProcPtr			tDSpContext_SwapBuffers         = NULL;

/*֐vg^Cv*/
/*Mac OS X p DrawSprocket IPI*/
/*DSpCallbackUPP C^[tF[X*/
static DSpCallbackUPP							NewDSpCallbackUPP_X(DSpCallbackProcPtr);
static void										DisposeDSpCallbackUPP_X(DSpCallbackUPP);
static Boolean									InvokeDSpCallbackUPP_X(DSpContextReference,
																	 void*,
																	 DSpCallbackUPP);

/*Mac OS 9.x p DrawSprocket IPI*/
/*DSpCallbackUPP C^[tF[X*/
static DSpCallbackUPP							NewDSpCallbackUPP_Classic(DSpCallbackProcPtr);
static void										DisposeDSpCallbackUPP_Classic(DSpCallbackUPP);
static Boolean									InvokeDSpCallbackUPP_Classic(DSpContextReference,
																			 void*,
																			 DSpCallbackUPP);


#pragma mark -- Carbon DrawSprocket API --

/*DSpCallbackUPP C^[tF[X*/
/*
	      ֐ : NewDSpCallbackUPP
	        @\ : NewDSpCallbackUPP API
	         : userRoutine      NewDSpCallbackUPP API userRoutine p[^ɓnl
	      ߂l : NewDSpCallbackUPP API ߂l
	        l : 1. s OS ̃o[W𔻒肵AK؂ IPI Ăяo
*/
DSpCallbackUPP									NewDSpCallbackUPP(DSpCallbackProcPtr	userRoutine)
{
	/*ϐ錾*/
	static NewDSpCallbackUPPProcPtr					apiNewDSpCallbackUPP[2] = {&NewDSpCallbackUPP_Classic,
																			   &NewDSpCallbackUPP_X};

	/**/
	return (*(apiNewDSpCallbackUPP[RuntimeHash()]))(userRoutine);
}

/*
	      ֐ : DisposeDSpCallbackUPP
	        @\ : DisposeDSpCallbackUPP API
	         : userUPP      DisposeDSpCallbackUPP API userUPP p[^ɓnl
	      ߂l : DisposeDSpCallbackUPP API ߂l
	        l : 1. s OS ̃o[W𔻒肵AK؂ IPI Ăяo
*/
void											DisposeDSpCallbackUPP(DSpCallbackUPP	userUPP)
{
	/*ϐ錾*/
	static DisposeDSpCallbackUPPProcPtr				apiDisposeDSpCallbackUPP[2] = {&DisposeDSpCallbackUPP_Classic,
																				   &DisposeDSpCallbackUPP_X};

	/**/
	(*(apiDisposeDSpCallbackUPP[RuntimeHash()]))(userUPP);
}

/*
	      ֐ : InvokeDSpCallbackUPP
	        @\ : InvokeDSpCallbackUPP API
	         : inContext      InvokeDSpCallbackUPP API inContext p[^ɓnl
				   inRefCon       InvokeDSpCallbackUPP API inRefCon  p[^ɓnl
				   userUPP        InvokeDSpCallbackUPP API userUPP   p[^ɓnl
	      ߂l : InvokeDSpCallbackUPP API ߂l
	        l : 1. s OS ̃o[W𔻒肵AK؂ IPI Ăяo
*/
Boolean											InvokeDSpCallbackUPP(DSpContextReference	inContext,
																	 void*					inRefCon,
																	 DSpCallbackUPP			userUPP)
{
	/*ϐ錾*/
	static InvokeDSpCallbackUPPProcPtr				apiInvokeDSpCallbackUPP[2] = {&InvokeDSpCallbackUPP_Classic,
																				  &InvokeDSpCallbackUPP_X};

	/**/
	return (*(apiInvokeDSpCallbackUPP[RuntimeHash()]))(inContext,
													   inRefCon,
													   userUPP);
}

/*DSp IuWFNgC^[tF[X*/
/*
	      ֐ : DSpStartup
	        @\ : DSpStartup API
	         : 
	      ߂l : DSpStartup API ߂l
	        l : 
*/
OSStatus										DSpStartup(void)
{
	/*ϐ錾*/
	static const char*								CSTR_LIB_NAME[2] = {"DrawSprocketLib",
																		"DrawSprocket.framework"};
	OSStatus										si32Err          = cfragNoSymbolErr;
	CFStringRef										strLibName       = NULL;

	/**/
	/*DrawSprocket Cũ[h*/
	if(FALSE == bInit)
	{
		strLibName = CFStringCreateWithCString(kCFAllocatorDefault,
											   CSTR_LIB_NAME[RuntimeHash()],
											   CFStringGetSystemEncoding());
		if(NULL != strLibName)
		{
			si32Err = LoadGSpLibrary(strLibName,
									 &lib);
			CFRelease(strLibName);
		}
	}
	else
		si32Err = noErr;
	/*DSpStartup API s*/
	if(noErr == si32Err)
	{
		bInit = TRUE;
		if(NULL == tDSpStartup)
			tDSpStartup = (DSpStartupProcPtr)(GetGSpAPIAddress(lib,
															   CFSTR("DSpStartup")));
		if(NULL != tDSpStartup)
			si32Err = (*tDSpStartup)();
		else
			si32Err = cfragNoSymbolErr;
	}
	return si32Err;
}

/*
	      ֐ : DSpShutdown
	        @\ : DSpShutdown API
	         : 
	      ߂l : DSpShutdown API ߂l
	        O : 
	        l : 
*/
OSStatus										DSpShutdown(void)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpShutdown API s*/
	if(NULL == tDSpShutdown)
		tDSpShutdown = (DSpShutdownProcPtr)(GetGSpAPIAddress(lib,
															 CFSTR("DSpShutdown")));
	if(NULL != tDSpShutdown)
		si32Err = (*tDSpShutdown)();
	else
		si32Err = cfragNoSymbolErr;
	/*DrawSprocket CũA[h*/
	if(noErr == si32Err)
	{
		UnloadGSpLibrary(&lib);
		bInit                           = FALSE;
		/*֐|C^̏*/
		/*DSpCallbackUPP C^[tF[X*/
		tNewDSpCallbackUPP              = NULL;
		tDisposeDSpCallbackUPP          = NULL;
		tInvokeDSpCallbackUPP           = NULL;
		/*DSp IuWFNgC^[tF[X*/
		tDSpStartup                     = NULL;
		tDSpShutdown                    = NULL;
		tDSpGetVersion                  = NULL;
		tDSpGetMouse                    = NULL;
		tDSpGetCurrentContext           = NULL;
		tDSpGetFirstContext             = NULL;
		tDSpGetNextContext              = NULL;
		tDSpSetDebugMode                = NULL;
		tDSpSetBlankingColor            = NULL;
		tDSpProcessEvent                = NULL;
		tDSpFindContextFromPoint        = NULL;
		tDSpFindBestContext             = NULL;
		tDSpFindBestContextOnDisplayID  = NULL;
		/*DSpContext IuWFNgC^[tF[X*/
		tDSpContext_Release             = NULL;
		tDSpContext_Dispose             = NULL;
		tDSpContext_GetMonitorFrequency = NULL;
		tDSpContext_GetAttributes       = NULL;
		tDSpContext_Reserve             = NULL;
		tDSpContext_GetCLUTEntries      = NULL;
		tDSpContext_SetCLUTEntries      = NULL;
		tDSpContext_GetState            = NULL;
		tDSpContext_SetState            = NULL;
		tDSpContext_IsBusy              = NULL;
		tDSpContext_GetDisplayID        = NULL;
		tDSpContext_GetFrontBuffer      = NULL;
		tDSpContext_GetBackBuffer       = NULL;
		tDSpContext_GlobalToLocal       = NULL;
		tDSpContext_LocalToGlobal       = NULL;
		tDSpContext_FadeGammaIn         = NULL;
		tDSpContext_FadeGammaOut        = NULL;
		tDSpContext_FadeGamma           = NULL;
		tDSpContext_Queue               = NULL;
		tDSpContext_Switch              = NULL;
		tDSpContext_SwapBuffers         = NULL;
	}
	return si32Err;
}

/*
	      ֐ : DSpGetVersion_X
	        @\ : DSpGetVersion API
	         : 
	      ߂l : DSpGetVersion API ߂l
	        l : 
*/
NumVersion										DSpGetVersion(void)
{
	/*ϐ錾*/
	NumVersion										versNum = {0, 0, 0, 0};

	/*p[^*/
	if(FALSE == bInit)
		return versNum;

	/**/
	/*DSpGetVersion API s*/
	if(NULL == tDSpGetVersion)
		tDSpGetVersion = (DSpGetVersionProcPtr)(GetGSpAPIAddress(lib,
																 CFSTR("DSpGetVersion")));
	if(NULL != tDSpGetVersion)
		versNum = (*tDSpGetVersion)();
	return versNum;
}

/*
	      ֐ : DSpGetMouse
	        @\ : DSpGetMouse API
	         : outGlobalPoint      DSpGetMouse API outGlobalPoint p[^ɓnl
	      ߂l : DSpGetMouse API ߂l
	        l : 
*/
OSStatus										DSpGetMouse(Point*	outGlobalPoint)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpGetMouse API s*/
	if(NULL == tDSpGetMouse)
		tDSpGetMouse = (DSpGetMouseProcPtr)(GetGSpAPIAddress(lib,
															 CFSTR("DSpGetMouse")));
	if(NULL != tDSpGetMouse)
		si32Err = (*tDSpGetMouse)(outGlobalPoint);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpGetCurrentContext
	        @\ : DSpGetCurrentContext API
	         : inDisplayID      DSpGetCurrentContext API inDisplayID p[^ɓnl
				   outContext   o    DSpGetCurrentContext API outContext  p[^ɓnl
	      ߂l : DSpGetCurrentContext API ߂l
	        l : 
*/
OSStatus										DSpGetCurrentContext(DisplayIDType			inDisplayID,
																	 DSpContextReference*	outContext)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpGetCurrentContext API s*/
	if(NULL == tDSpGetCurrentContext)
		tDSpGetCurrentContext = (DSpGetCurrentContextProcPtr)(GetGSpAPIAddress(lib,
																			   CFSTR("DSpGetCurrentContext")));
	if(NULL != tDSpGetCurrentContext)
		si32Err = (*tDSpGetCurrentContext)(inDisplayID,
										   outContext);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpGetFirstContext
	        @\ : DSpGetFirstContext API
	         : inDisplayID      DSpGetFirstContext API inDisplayID p[^ɓnl
				   outContext   o    DSpGetFirstContext API outContext  p[^ɓnl
	      ߂l : DSpGetFirstContext API ߂l
	        l : 
*/
OSStatus										DSpGetFirstContext(DisplayIDType		inDisplayID,
																   DSpContextReference*	outContext)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpGetFirstContext API s*/
	if(NULL == tDSpGetFirstContext)
		tDSpGetFirstContext = (DSpGetFirstContextProcPtr)(GetGSpAPIAddress(lib,
																		   CFSTR("DSpGetFirstContext")));
	if(NULL != tDSpGetFirstContext)
		si32Err = (*tDSpGetFirstContext)(inDisplayID,
										 outContext);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpGetNextContext
	        @\ : DSpGetNextContext API
	         : inCurrentContext      DSpGetNextContext API inCurrentContext p[^ɓnl
				   outContext        o    DSpGetNextContext API outContext       p[^ɓnl
	      ߂l : DSpGetNextContext API ߂l
	        l : 
*/
OSStatus										DSpGetNextContext(DSpContextReference	inCurrentContext,
																  DSpContextReference*	outContext)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpGetNextContext API s*/
	if(NULL == tDSpGetNextContext)
		tDSpGetNextContext = (DSpGetNextContextProcPtr)(GetGSpAPIAddress(lib,
																		 CFSTR("DSpGetNextContext")));
	if(NULL != tDSpGetNextContext)
		si32Err = (*tDSpGetNextContext)(inCurrentContext,
										outContext);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpSetDebugMode
	        @\ : DSpSetDebugMode API
	         : inDebugMode      DSpSetDebugMode API inDebugMode p[^ɓnl
	      ߂l : DSpSetDebugMode API ߂l
	        l : 
*/
OSStatus										DSpSetDebugMode(Boolean	inDebugMode)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpSetDebugMode API s*/
	if(NULL == tDSpSetDebugMode)
		tDSpSetDebugMode = (DSpSetDebugModeProcPtr)(GetGSpAPIAddress(lib,
																	 CFSTR("DSpSetDebugMode")));
	if(NULL != tDSpSetDebugMode)
		si32Err = (*tDSpSetDebugMode)(inDebugMode);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpSetBlankingColor
	        @\ : DSpSetBlankingColor API
	         : inRGBColor      DSpSetBlankingColor API inRGBColor p[^ɓnl
	      ߂l : DSpSetBlankingColor API ߂l
	        l : 
*/
OSStatus										DSpSetBlankingColor(const RGBColor*	inRGBColor)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpSetBlankingColor API s*/
	if(NULL == tDSpSetBlankingColor)
		tDSpSetBlankingColor = (DSpSetBlankingColorProcPtr)(GetGSpAPIAddress(lib,
																			 CFSTR("DSpSetBlankingColor")));
	if(NULL != tDSpSetBlankingColor)
		si32Err = (*tDSpSetBlankingColor)(inRGBColor);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpProcessEvent
	        @\ : DSpProcessEvent API
	         : inEvent                   DSpProcessEvent API inEvent              p[^ɓnl
				   outEventWasProcessed  o    DSpProcessEvent API outEventWasProcessed p[^ɓnl
	      ߂l : DSpProcessEvent API ߂l
	        l : 
*/
OSStatus										DSpProcessEvent(EventRecord*	inEvent,
																Boolean*		outEventWasProcessed)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpProcessEvent API s*/
	if(NULL == tDSpProcessEvent)
		tDSpProcessEvent = (DSpProcessEventProcPtr)(GetGSpAPIAddress(lib,
																	 CFSTR("DSpProcessEvent")));
	if(NULL != tDSpProcessEvent)
		si32Err = (*tDSpProcessEvent)(inEvent,
									  outEventWasProcessed);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpFindContextFromPoint
	        @\ : DSpFindContextFromPoint API
	         : inGlobalPoint      DSpFindContextFromPoint API inGlobalPoint  p[^ɓnl
				   outContext     o    DSpFindContextFromPoint API outContext     p[^ɓnl
	      ߂l : DSpFindContextFromPoint API ߂l
	        l : 
*/
OSStatus										DSpFindContextFromPoint(Point					inGlobalPoint,
																		DSpContextReference*	outContext)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpFindContextFromPoint API s*/
	if(NULL == tDSpFindContextFromPoint)
		tDSpFindContextFromPoint = (DSpFindContextFromPointProcPtr)(GetGSpAPIAddress(lib,
																					 CFSTR("DSpFindContextFromPoint")));
	if(NULL != tDSpFindContextFromPoint)
		si32Err = (*tDSpFindContextFromPoint)(inGlobalPoint,
											  outContext);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpFindBestContext
	        @\ : DSpFindBestContext API
	         : inDesiredAttributes      DSpFindBestContext API inDesiredAttributes p[^ɓnl
				   outContext           o    DSpFindBestContext API outContext          p[^ɓnl
	      ߂l : DSpFindBestContext API ߂l
	        l : 
*/
OSStatus										DSpFindBestContext(DSpContextAttributesPtr	inDesiredAttributes,
																   DSpContextReference*		outContext)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpFindBestContext API s*/
	if(NULL == tDSpFindBestContext)
		tDSpFindBestContext = (DSpFindBestContextProcPtr)(GetGSpAPIAddress(lib,
																		   CFSTR("DSpFindBestContext")));
	if(NULL != tDSpFindBestContext)
		si32Err = (*tDSpFindBestContext)(inDesiredAttributes,
										 outContext);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	ANZXw : static, public
	      ֐ : CFMDrawSprocket_X::DSpFindBestContextOnDisplayID
	        @\ : DSpFindBestContextOnDisplayID API
	         : inDesiredAttributes      DSpFindBestContextOnDisplayID API inDesiredAttributes p[^ɓnl
				   outContext           o    DSpFindBestContextOnDisplayID API outContext          p[^ɓnl
	      ߂l : DSpFindBestContextOnDisplayID API ߂l
	        O : 
	        l : 
*/
OSStatus										DSpFindBestContextOnDisplayID(DSpContextAttributesPtr	inDesiredAttributes,
																			  DSpContextReference*		outContext,
																			  DisplayIDType				inDisplayID)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpFindBestContextOnDisplayID API s*/
	if(NULL == tDSpFindBestContextOnDisplayID)
		tDSpFindBestContextOnDisplayID = 
							(DSpFindBestContextOnDisplayIDProcPtr)(GetGSpAPIAddress(lib,
																					CFSTR("DSpFindBestContextOnDisplayID")));
	if(NULL != tDSpFindBestContextOnDisplayID)
		si32Err = (*tDSpFindBestContextOnDisplayID)(inDesiredAttributes,
													outContext,
													inDisplayID);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*DSpContext IuWFNgC^[tF[X*/
/*
	      ֐ : DSpContext_Release
	        @\ : DSpContext_Release API
	         : inContext      DSpContext_Release API inContext p[^ɓnl
	      ߂l : DSpContext_Release API ߂l
	        l : 
*/
OSStatus										DSpContext_Release(DSpContextReference	inContext)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_Release API s*/
	if(NULL == tDSpContext_Release)
		tDSpContext_Release = (DSpContext_ReleaseProcPtr)(GetGSpAPIAddress(lib,
																		   CFSTR("DSpContext_Release")));
	if(NULL != tDSpContext_Release)
		si32Err = (*tDSpContext_Release)(inContext);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_Dispose
	        @\ : DSpContext_Dispose API
	         : inContext      DSpContext_Dispose API inContext p[^ɓnl
	      ߂l : DSpContext_Dispose API ߂l
	        l : 
*/
OSStatus										DSpContext_Dispose(DSpContextReference	inContext)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_Dispose API s*/
	if(NULL == tDSpContext_Dispose)
		tDSpContext_Dispose = (DSpContext_DisposeProcPtr)(GetGSpAPIAddress(lib,
																		   CFSTR("DSpContext_Dispose")));
	if(NULL != tDSpContext_Dispose)
		si32Err = (*tDSpContext_Dispose)(inContext);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_GetMonitorFrequency
	        @\ : DSpContext_GetMonitorFrequency API
	         : inContext         DSpContext_GetMonitorFrequency API inContext    p[^ɓnl
				   outFrequency  o    DSpContext_GetMonitorFrequency API outFrequency p[^ɓnl
	      ߂l : DSpContext_GetMonitorFrequency API ߂l
	        l : 
*/
OSStatus										DSpContext_GetMonitorFrequency(DSpContextReferenceConst	inContext,
																			   Fixed*					outFrequency)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_GetMonitorFrequency API s*/
	if(NULL == tDSpContext_GetMonitorFrequency)
		tDSpContext_GetMonitorFrequency = 
							(DSpContext_GetMonitorFrequencyProcPtr)(GetGSpAPIAddress(lib,
																					 CFSTR("DSpContext_GetMonitorFrequency")));
	if(NULL != tDSpContext_GetMonitorFrequency)
		si32Err = (*tDSpContext_GetMonitorFrequency)(inContext,
													 outFrequency);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_GetAttributes
	        @\ : DSpContext_GetAttributes API
	         : inContext          DSpContext_GetAttributes API inContext     p[^ɓnl
				   outAttributes  o    DSpContext_GetAttributes API outAttributes p[^ɓnl
	      ߂l : DSpContext_GetAttributes API ߂l
	        l : 
*/
OSStatus										DSpContext_GetAttributes(DSpContextReferenceConst	inContext,
																		 DSpContextAttributesPtr	outAttributes)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_GetAttributes API s*/
	if(NULL == tDSpContext_GetAttributes)
		tDSpContext_GetAttributes = (DSpContext_GetAttributesProcPtr)(GetGSpAPIAddress(lib,
																					   CFSTR("DSpContext_GetAttributes")));
	if(NULL != tDSpContext_GetAttributes)
		si32Err = (*tDSpContext_GetAttributes)(inContext,
											   outAttributes);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_Reserve
	        @\ : DSpContext_Reserve API
	         : inContext                DSpContext_Reserve API inContext           p[^ɓnl
				   inDesiredAttributes      DSpContext_Reserve API inDesiredAttributes p[^ɓnl
	      ߂l : DSpContext_Reserve API ߂l
	        l : 
*/
OSStatus										DSpContext_Reserve(DSpContextReference		inContext,
																   DSpContextAttributesPtr	inDesiredAttributes)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_Reserve API s*/
	if(NULL == tDSpContext_Reserve)
		tDSpContext_Reserve = (DSpContext_ReserveProcPtr)(GetGSpAPIAddress(lib,
																		   CFSTR("DSpContext_Reserve")));
	if(NULL != tDSpContext_Reserve)
		si32Err = (*tDSpContext_Reserve)(inContext,
										 inDesiredAttributes);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_GetCLUTEntries
	        @\ : DSpContext_GetCLUTEntries API
	         : inContext            DSpContext_GetCLUTEntries API inContext       p[^ɓnl
				   outEntries       o    DSpContext_GetCLUTEntries API outEntries      p[^ɓnl
				   inStartingEntry      DSpContext_GetCLUTEntries API inStartingEntry p[^ɓnl
				   inLastEntry          DSpContext_GetCLUTEntries API inLastEntry     p[^ɓnl
	      ߂l : DSpContext_GetCLUTEntries API ߂l
	        l : 1. s OS ̃o[W𔻒肵AK؂ API Ăяo
*/
OSStatus										DSpContext_GetCLUTEntries(DSpContextReferenceConst	inContext,
																		  ColorSpec*				outEntries,
																		  UInt16					inStartingEntry,
																		  UInt16					inLastEntry)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_GetCLUTEntries API s*/
	if(NULL == tDSpContext_GetCLUTEntries)
		tDSpContext_GetCLUTEntries = (DSpContext_GetCLUTEntriesProcPtr)(GetGSpAPIAddress(lib,
																						 CFSTR("DSpContext_GetCLUTEntries")));
	if(NULL != tDSpContext_GetCLUTEntries)
		si32Err = (*tDSpContext_GetCLUTEntries)(inContext,
												outEntries,
												inStartingEntry,
												inLastEntry);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_SetCLUTEntries
	        @\ : DSpContext_SetCLUTEntries API
	         : inContext            DSpContext_SetCLUTEntries API inContext       p[^ɓnl
				   inEntries            DSpContext_SetCLUTEntries API inEntries       p[^ɓnl
				   inStartingEntry      DSpContext_SetCLUTEntries API inStartingEntry p[^ɓnl
				   inLastEntry          DSpContext_SetCLUTEntries API inLastEntry     p[^ɓnl
	      ߂l : DSpContext_SetCLUTEntries API ߂l
	        l : 1. s OS ̃o[W𔻒肵AK؂ API Ăяo
*/
OSStatus										DSpContext_SetCLUTEntries(DSpContextReference	inContext,
																		  const ColorSpec*		inEntries,
																		  UInt16				inStartingEntry,
																		  UInt16				inLastEntry)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_SetCLUTEntries API s*/
	if(NULL == tDSpContext_SetCLUTEntries)
		tDSpContext_SetCLUTEntries = (DSpContext_SetCLUTEntriesProcPtr)(GetGSpAPIAddress(lib,
																						 CFSTR("DSpContext_SetCLUTEntries")));
	if(NULL != tDSpContext_SetCLUTEntries)
		si32Err = (*tDSpContext_SetCLUTEntries)(inContext,
												inEntries,
												inStartingEntry,
												inLastEntry);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_GetState
	        @\ : DSpContext_GetState API
	         : inContext      DSpContext_GetState API inContext p[^ɓnl
				   outState   o    DSpContext_GetState API outState  p[^ɓnl
	      ߂l : DSpContext_GetState API ߂l
	        l : 
*/
OSStatus										DSpContext_GetState(DSpContextReferenceConst	inContext,
																	DSpContextState*			outState)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_GetState API s*/
	if(NULL == tDSpContext_GetState)
		tDSpContext_GetState = (DSpContext_GetStateProcPtr)(GetGSpAPIAddress(lib,
																			 CFSTR("DSpContext_GetState")));
	if(NULL != tDSpContext_GetState)
		si32Err = (*tDSpContext_GetState)(inContext,
										  outState);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	ANZXw : static, public
	      ֐ : CFMDrawSprocket_X::DSpContext_SetState
	        @\ : DSpContext_SetState API
	         : inContext      DSpContext_SetState API inContext p[^ɓnl
				   inState        DSpContext_SetState API inState   p[^ɓnl
	      ߂l : DSpContext_SetState API ߂l
	        O : 
	        l : 
*/
OSStatus										DSpContext_SetState(DSpContextReference	inContext,
																	DSpContextState		inState)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_SetState API s*/
	if(NULL == tDSpContext_SetState)
		tDSpContext_SetState = (DSpContext_SetStateProcPtr)(GetGSpAPIAddress(lib,
																			 CFSTR("DSpContext_SetState")));
	if(NULL != tDSpContext_SetState)
		si32Err = (*tDSpContext_SetState)(inContext,
										  inState);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_IsBusy
	        @\ : DSpContext_IsBusy API
	         : inContext        DSpContext_IsBusy API inContext   p[^ɓnl
				   outBusyFlag  o    DSpContext_IsBusy API outBusyFlag p[^ɓnl
	      ߂l : DSpContext_IsBusy API ߂l
	        l : 
*/
OSStatus										DSpContext_IsBusy(DSpContextReference	inContext,
																  Boolean*				outBusyFlag)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_IsBusy API s*/
	if(NULL == tDSpContext_IsBusy)
		tDSpContext_IsBusy = (DSpContext_IsBusyProcPtr)(GetGSpAPIAddress(lib,
																		 CFSTR("DSpContext_IsBusy")));
	if(NULL != tDSpContext_IsBusy)
		si32Err = (*tDSpContext_IsBusy)(inContext,
										outBusyFlag);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_GetDisplayID
	        @\ : DSpContext_GetDisplayID API
	         : inContext         DSpContext_GetDisplayID API inContext    p[^ɓnl
				   outDisplayID  o    DSpContext_GetDisplayID API outDisplayID p[^ɓnl
	      ߂l : DSpContext_GetDisplayID API ߂l
	        l : 
*/
OSStatus										DSpContext_GetDisplayID(DSpContextReferenceConst	inContext,
																		DisplayIDType*				outDisplayID)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_GetDisplayID API s*/
	if(NULL == tDSpContext_GetDisplayID)
		tDSpContext_GetDisplayID = (DSpContext_GetDisplayIDProcPtr)(GetGSpAPIAddress(lib,
																					 CFSTR("DSpContext_GetDisplayID")));
	if(NULL != tDSpContext_GetDisplayID)
		si32Err = (*tDSpContext_GetDisplayID)(inContext,
											  outDisplayID);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_GetFrontBuffer
	        @\ : DSpContext_GetFrontBuffer API
	         : inContext           DSpContext_GetFrontBuffer API inContext      p[^ɓnl
				   outFrontBuffer  o    DSpContext_GetFrontBuffer API outFrontBuffer p[^ɓnl
	      ߂l : DSpContext_GetFrontBuffer API ߂l
	        l : 
*/
OSStatus										DSpContext_GetFrontBuffer(DSpContextReferenceConst	inContext,
																		  CGrafPtr*					outFrontBuffer)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_GetFrontBuffer API s*/
	if(NULL == tDSpContext_GetFrontBuffer)
		tDSpContext_GetFrontBuffer = (DSpContext_GetFrontBufferProcPtr)(GetGSpAPIAddress(lib,
																						 CFSTR("DSpContext_GetFrontBuffer")));
	if(NULL != tDSpContext_GetFrontBuffer)
		si32Err = (*tDSpContext_GetFrontBuffer)(inContext,
												outFrontBuffer);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_GetBackBuffer
	        @\ : DSpContext_GetBackBuffer API
	         : inContext          DSpContext_GetBackBuffer API inContext     p[^ɓnl
				   inBufferKind       DSpContext_GetBackBuffer API inBufferKind  p[^ɓnl
				   outBackBuffer  o    DSpContext_GetBackBuffer API outBackBuffer p[^ɓnl
	      ߂l : DSpContext_GetBackBuffer API ߂l
	        l : 
*/
OSStatus										DSpContext_GetBackBuffer(DSpContextReference	inContext,
																		 DSpBufferKind			inBufferKind,
																		 CGrafPtr*				outBackBuffer)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_GetBackBuffer API s*/
	if(NULL == tDSpContext_GetBackBuffer)
		tDSpContext_GetBackBuffer = (DSpContext_GetBackBufferProcPtr)(GetGSpAPIAddress(lib,
																					   CFSTR("DSpContext_GetBackBuffer")));
	if(NULL != tDSpContext_GetBackBuffer)
		si32Err = (*tDSpContext_GetBackBuffer)(inContext,
											   inBufferKind,
											   outBackBuffer);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_GlobalToLocal
	        @\ : DSpContext_GlobalToLocal API
	         : inContext      DSpContext_GlobalToLocal API inContext p[^ɓnl
				   ioPoint    o  DSpContext_GlobalToLocal API ioPoint   p[^ɓnl
	      ߂l : DSpContext_GlobalToLocal API ߂l
	        l : 
*/
OSStatus										DSpContext_GlobalToLocal(DSpContextReference	inContext,
																		 Point*					ioPoint)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_GlobalToLocal API s*/
	if(NULL == tDSpContext_GlobalToLocal)
		tDSpContext_GlobalToLocal = (DSpContext_GlobalToLocalProcPtr)(GetGSpAPIAddress(lib,
																					   CFSTR("DSpContext_GlobalToLocal")));
	if(NULL != tDSpContext_GlobalToLocal)
		si32Err = (*tDSpContext_GlobalToLocal)(inContext,
											   ioPoint);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_LocalToGlobal
	        @\ : DSpContext_LocalToGlobal API
	         : inContext      DSpContext_LocalToGlobal API inContext p[^ɓnl
				   ioPoint    o  DSpContext_LocalToGlobal API ioPoint   p[^ɓnl
	      ߂l : DSpContext_LocalToGlobal API ߂l
	        l : 
*/
OSStatus										DSpContext_LocalToGlobal(DSpContextReference	inContext,
																		 Point*					ioPoint)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_LocalToGlobal API s*/
	if(NULL == tDSpContext_LocalToGlobal)
		tDSpContext_LocalToGlobal = (DSpContext_LocalToGlobalProcPtr)(GetGSpAPIAddress(lib,
																					   CFSTR("DSpContext_LocalToGlobal")));
	if(NULL != tDSpContext_LocalToGlobal)
		si32Err = (*tDSpContext_LocalToGlobal)(inContext,
											   ioPoint);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_FadeGammaIn
	        @\ : DSpContext_FadeGammaIn API
	         : inContext                 DSpContext_FadeGammaIn API inContext            p[^ɓnl
				   inZeroIntensityColor      DSpContext_FadeGammaIn API inZeroIntensityColor p[^ɓnl
	      ߂l : DSpContext_FadeGammaIn API ߂l
	        l : 
*/
OSStatus										DSpContext_FadeGammaIn(DSpContextReference	inContext,
																	   RGBColor*			inZeroIntensityColor)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_FadeGammaIn API s*/
	if(NULL == tDSpContext_FadeGammaIn)
		tDSpContext_FadeGammaIn = (DSpContext_FadeGammaInProcPtr)(GetGSpAPIAddress(lib,
																				   CFSTR("DSpContext_FadeGammaIn")));
	if(NULL != tDSpContext_FadeGammaIn)
		si32Err = (*tDSpContext_FadeGammaIn)(inContext,
											 inZeroIntensityColor);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_FadeGammaOut
	        @\ : DSpContext_FadeGammaOut API
	         : inContext                 DSpContext_FadeGammaOut API inContext            p[^ɓnl
				   inZeroIntensityColor      DSpContext_FadeGammaOut API inZeroIntensityColor p[^ɓnl
	      ߂l : DSpContext_FadeGammaOut API ߂l
	        l : 
*/
OSStatus										DSpContext_FadeGammaOut(DSpContextReference	inContext,
																		RGBColor*			inZeroIntensityColor)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_FadeGammaOut API s*/
	if(NULL == tDSpContext_FadeGammaOut)
		tDSpContext_FadeGammaOut = (DSpContext_FadeGammaOutProcPtr)(GetGSpAPIAddress(lib,
																					 CFSTR("DSpContext_FadeGammaOut")));
	if(NULL != tDSpContext_FadeGammaOut)
		si32Err = (*tDSpContext_FadeGammaOut)(inContext,
											  inZeroIntensityColor);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_FadeGamma
	        @\ : DSpContext_FadeGamma API
	         : inContext                         DSpContext_FadeGamma API inContext                    p[^ɓnl
				   inPercentOfOriginalIntensity      DSpContext_FadeGamma API inPercentOfOriginalIntensity p[^ɓnl
				   inZeroIntensityColor              DSpContext_FadeGamma API inZeroIntensityColor         p[^ɓnl
	      ߂l : DSpContext_FadeGamma API ߂l
	        l : 
*/
OSStatus										DSpContext_FadeGamma(DSpContextReference	inContext,
																	 SInt32					inPercentOfOriginalIntensity,
																	 RGBColor*				inZeroIntensityColor)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_FadeGamma API s*/
	if(NULL == tDSpContext_FadeGamma)
		tDSpContext_FadeGamma = (DSpContext_FadeGammaProcPtr)(GetGSpAPIAddress(lib,
																			   CFSTR("DSpContext_FadeGamma")));
	if(NULL != tDSpContext_FadeGamma)
		si32Err = (*tDSpContext_FadeGamma)(inContext,
										   inPercentOfOriginalIntensity,
										   inZeroIntensityColor);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_Queue
	        @\ : DSpContext_Queue API
	         : inParentContext          DSpContext_Queue API inParentContext     p[^ɓnl
				   inChildContext           DSpContext_Queue API inChildContext      p[^ɓnl
				   inDesiredAttributes      DSpContext_Queue API inDesiredAttributes p[^ɓnl
	      ߂l : DSpContext_Queue API ߂l
	        l : 1. s OS ̃o[W𔻒肵AK؂ API Ăяo
*/
OSStatus										DSpContext_Queue(DSpContextReference		inParentContext,
																 DSpContextReference		inChildContext,
																 DSpContextAttributesPtr	inDesiredAttributes)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_Queue API s*/
	if(NULL == tDSpContext_Queue)
		tDSpContext_Queue = (DSpContext_QueueProcPtr)(GetGSpAPIAddress(lib,
																	   CFSTR("DSpContext_Queue")));
	if(NULL != tDSpContext_Queue)
		si32Err = (*tDSpContext_Queue)(inParentContext,
									   inChildContext,
									   inDesiredAttributes);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_Switch
	        @\ : DSpContext_Switch API
	         : inOldContext      DSpContext_Switch API inOldContext p[^ɓnl
				   inNewContext      DSpContext_Switch API inNewContext p[^ɓnl
	      ߂l : DSpContext_Switch API ߂l
	        l : 1. s OS ̃o[W𔻒肵AK؂ API Ăяo
*/
OSStatus										DSpContext_Switch(DSpContextReference	inOldContext,
																  DSpContextReference	inNewContext)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_Switch API s*/
	if(NULL == tDSpContext_Switch)
		tDSpContext_Switch = (DSpContext_SwitchProcPtr)(GetGSpAPIAddress(lib,
																		 CFSTR("DSpContext_Switch")));
	if(NULL != tDSpContext_Switch)
		si32Err = (*tDSpContext_Switch)(inOldContext,
										inNewContext);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

/*
	      ֐ : DSpContext_SwapBuffers
	        @\ : DSpContext_SwapBuffers API
	         : inContext         DSpContext_SwapBuffers API inContext    p[^ɓnl
				   inBusyProc        DSpContext_SwapBuffers API inBusyProc   p[^ɓnl
				   inUserRefCon      DSpContext_SwapBuffers API inUserRefCon p[^ɓnl
	      ߂l : DSpContext_SwapBuffers API ߂l
	        l : 
*/
OSStatus										DSpContext_SwapBuffers(DSpContextReference	inContext,
																	   DSpCallbackUPP		inBusyProc,
																	   void*				inUserRefCon)
{
	/*ϐ錾*/
	OSStatus										si32Err;

	/*p[^*/
	if(FALSE == bInit)
		return kDSpNotInitializedErr;

	/**/
	/*DSpContext_SwapBuffers API s*/
	if(NULL == tDSpContext_SwapBuffers)
		tDSpContext_SwapBuffers = (DSpContext_SwapBuffersProcPtr)(GetGSpAPIAddress(lib,
																				   CFSTR("DSpContext_SwapBuffers")));
	if(NULL != tDSpContext_SwapBuffers)
		si32Err = (*tDSpContext_SwapBuffers)(inContext,
											 inBusyProc,
											 inUserRefCon);
	else
		si32Err = cfragNoSymbolErr;
	return si32Err;
}

#pragma mark -- DrawSprocket for Mac OS X ( CFM ) IPI --
/*DrawSprocket for Mac OS X ( CFM ) IPI*/
/*
	      ֐ : NewDSpCallbackUPP_X
	        @\ : Mac OS X p NewDSpCallbackUPP IPI
	         : userRoutine      DSpCallbackProcPtr ^ CFM ֐|C^
	      ߂l : DSpCallbackProcPtr ^ Mach-O ֐|C^
	        l : 1. CFM ֐|C^ Mach-O ֐|C^쐬Ă
				   2. gp DisposeDSpCallbackUPP ŉ邱
*/
DSpCallbackUPP									NewDSpCallbackUPP_X(DSpCallbackProcPtr	userRoutine)
{
	/*ϐ錾*/
	static const UInt32								UI32_CFM_GLUE[6] = {0x3D800000,
																		0x618C0000,
																		0x800C0000,
																		0x804C0004,
																		0x7C0903A6,
																		0x4E800420};
	UInt32*											ui32MFPtr;

	/*p[^*/
	if(NULL == userRoutine)
		return NULL;

	/**/
	/*CFM ֐|C^ Mach-O ֐|C^쐬*/
	ui32MFPtr = (UInt32*)(CFAllocatorAllocate(kCFAllocatorDefault,
											  sizeof(UI32_CFM_GLUE),
											  0));
	if(NULL != ui32MFPtr)
	{
	    ui32MFPtr[0] = UI32_CFM_GLUE[0] | ((UInt32)(userRoutine) >> 16);
	    ui32MFPtr[1] = UI32_CFM_GLUE[1] | ((UInt32)(userRoutine)  & 0xFFFF);
	    ui32MFPtr[2] = UI32_CFM_GLUE[2];
	    ui32MFPtr[3] = UI32_CFM_GLUE[3];
	    ui32MFPtr[4] = UI32_CFM_GLUE[4];
	    ui32MFPtr[5] = UI32_CFM_GLUE[5];
	    MakeDataExecutable(ui32MFPtr,
						   sizeof(UI32_CFM_GLUE));
	}
    return (DSpCallbackUPP)(ui32MFPtr);
}

/*
	      ֐ : DisposeDSpCallbackUPP_X
	        @\ : Mac OS X p DisposeDSpCallbackUPP IPI
	         : userUPP      DSpCallbackProcPtr ^ Mach-O ֐|C^
	      ߂l : DisposeDSpCallbackUPP API ߂l
	        l : 
*/
void											DisposeDSpCallbackUPP_X(DSpCallbackUPP	userUPP)
{
	/*p[^*/
	if(NULL == userUPP)
		return;

	/**/
	/*Mach-O ֐|C^*/
	CFAllocatorDeallocate(kCFAllocatorDefault,
						  userUPP);
}

/*
	      ֐ : InvokeDSpCallbackUPP_X
	        @\ : Mac OS X p InvokeDSpCallbackUPP IPI
	         : inContext      InvokeDSpCallbackUPP API inContext p[^ɓnl
				   inRefCon       InvokeDSpCallbackUPP API inRefCon  p[^ɓnl
				   userUPP        DSpCallbackProcPtr ^ Mach-O ֐|C^
	      ߂l : InvokeDSpCallbackUPP API ߂l
	        l : 
*/
Boolean											InvokeDSpCallbackUPP_X(DSpContextReference	inContext,
																	   void*				inRefCon,
																	   DSpCallbackUPP		userUPP)
{
	/*ϐ錾*/
	UInt32*											ui32CFMGluePtr = (UInt32*)(userUPP);
	UInt32											ui32ProcAddr;
	DSpCallbackProcPtr								fpDSpCallback;
	Boolean											bRet           = FALSE;

	/**/
	/*Mach-O ֐|C^ CFM ֐|C^ɕϊ*/
	ui32ProcAddr = ((ui32CFMGluePtr[0] & 0xFFFF) << 16) + (ui32CFMGluePtr[1] & 0xFFFF);
	fpDSpCallback = (DSpCallbackProcPtr)(ui32ProcAddr);
	/*֐s*/
	if(NULL != fpDSpCallback)
		bRet = (*fpDSpCallback)(inContext,
								inRefCon);
	return bRet;
}

#pragma mark -- DrawSprocket for Mac OS 9.x IPI --
/*DrawSprocket for Mac OS 9.x IPI*/
/*
	      ֐ : NewDSpCallbackUPP_Classic
	        @\ : Mac OS 9.x p NewDSpCallbackUPP IPI
	         : userRoutine      NewDSpCallbackUPP API userRoutine p[^ɓnl
	      ߂l : NewDSpCallbackUPP API ߂l
	        l : 1. userRoutine ̂܂ܕԂ
*/
DSpCallbackUPP									NewDSpCallbackUPP_Classic(DSpCallbackProcPtr	userRoutine)
{
	/**/
    return (DSpCallbackUPP)(userRoutine);
}

/*
	      ֐ : DisposeDSpCallbackUPP_Classic
	        @\ : Mac OS 9.x p DisposeDSpCallbackUPP IPI
	         : userUPP      DisposeDSpCallbackUPP API userUPP p[^ɓnl
	      ߂l : DisposeDSpCallbackUPP API ߂l
	        l : 1. Ȃ
*/
void											DisposeDSpCallbackUPP_Classic(DSpCallbackUPP	userUPP)
{
	/**/
	/*Ȃ*/
	#pragma unused(userUPP)
}

/*
	      ֐ : InvokeDSpCallbackUPP_Classic
	        @\ : Mac OS 9.x p InvokeDSpCallbackUPP IPI
	         : inContext      InvokeDSpCallbackUPP API inContext p[^ɓnl
				   inRefCon       InvokeDSpCallbackUPP API inRefCon  p[^ɓnl
				   userUPP        InvokeDSpCallbackUPP API userUPP   p[^ɓnl
	      ߂l : InvokeDSpCallbackUPP API ߂l
	        l : 
*/
Boolean											InvokeDSpCallbackUPP_Classic(DSpContextReference	inContext,
																			 void*					inRefCon,
																			 DSpCallbackUPP			userUPP)
{
	/*ϐ錾*/
	DSpCallbackProcPtr								fpDSpCallback = (DSpCallbackProcPtr)(userUPP);
	Boolean											bRet          = FALSE;

	/**/
	/*UPP ̂܂܊֐|C^Ȃ̂ł̂܂܎s*/
	if(NULL != fpDSpCallback)
		bRet = (*fpDSpCallback)(inContext,
								inRefCon);
	return bRet;
}

#endif	/*TARGET_API_MAC_CARBON && TARGET_RT_MAC_CFM*/