/*
	t@C : CFMDrawSprocket.h
	e         : Mac OS 9.x / Mac OS X ptXN[[`i DrawSprocket gpj
	     : Mac OS 9.x : DrawSprocket Version 1.0  ȍ~
				   Mac OS X   : DrawSprocket Version 1.99 ȍ~i Mac OS X 10.0.3 ȍ~ j
	l         : 1. DSpBeginFullScreen, DSpEndFullScreen ĂяoO DSpStartup API ֐
				      Ăяo
				   2. tXN[́ACxg[v WaitNextEvent API ֐ĂяoA
				      kCxgłȂ DSpProcessEvent API ֐Ăяo
				   3. AvP[VIO DSpShutdown API ֐Ăяo
*/
#ifndef __DSPFULLSCREEN__
#define __DSPFULLSCREEN__

#ifndef __CFMDRAWSPROCKET__
#include "CFMDrawSprocket.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*^`*/
/*tXN[ʐtO*/
enum DSpFullScreenFlag
{
	dspFullScreenHideCursor = 1L << 0
};
typedef enum DSpFullScreenFlag					DSpFullScreenFlag;

/*XN[ԁiC^[tF[XJj*/
typedef struct _FullScreenStatus*				FullScreenStatusRef;

/*֐vg^Cv*/
/*
	      ֐ : DSpBeginFullScreen
	        @\ : tXN[
	         : ui32Width                tXN[ʂ̕
				   ui32Height               tXN[ʂ̍
				   ui32BitsPerPixel         tXN[ʂ̃rbg[x
				                                i 16  32 Ij
				   RGB_ERASE_COLOR_PTR      tXN[ʂ̏wiF
				   enmFlags                 tXN[tO
				       0                       c J[\\
				       dspFullScreenHideCursor c J[\B
				   wFullScreenPtr       o    tXN[ʂւ̎Q
				   screenStatePtr       o    XN[Ԃւ̎Q
	      ߂l :    noErr : I
				   paramErr : wFullScreenPtr,  screenStatePtr Ƀk|C^n
				   ̑   : G[
	        l : 1. ߂l noErr ȊȌꍇAtXN[Ȃ
				   2. ߂l noErr, paramErr ȊȌꍇAwFullScreenPtr, screenStatePtr ɂ
				      k|C^Ԃ
				   3. AvP[VIOɕK DSpEndFullScreen ĂяoA
				      tXN[ʂ邱
				   4. tXN[ꍇAj[o[͎IɉB
				   5. ). Mac OS X ł́AtXN[}EXɂ郁j[o[NbN͔Ȃ
				             iL[{[hV[gJbg͔j
*/
OSStatus										DSpBeginFullScreen(UInt32				ui32Width,
																   UInt32				ui32Height,
																   UInt32				ui32BitsPerPixel,
																   const RGBColor*		RGB_ERASE_COLOR_PTR,
																   DSpFullScreenFlag	enmFlags,
																   WindowRef*			wFullScreenPtr,
																   FullScreenStatusRef*	screenStatePtr);

/*
	      ֐ : DSpEndFullScreen
	        @\ : tXN[I
	         : restoreStatePtr          XN[Ԃւ̎Q
				                        o    k|C^ifXNgbvʂɖ߂ꍇj
				   enmFlags                 tXN[tO
				       0                       c J[\\
				       dspFullScreenHideCursor c J[\B
	      ߂l :    noErr : I
				   paramErr : restoreStatePtr Ƀk|C^nA
				              ͖ȃXN[ւ̎QƂn
				   ̑   : G[
	        l : 1. restoreStatePtr ɂ́ADSpBeginFullScreen ֐ screenStatePtr ɕԂꂽl
				      ̂܂ܓn
				   2. fXNgbvʂɖ߂Aj[o[͎Iɕ\
				   3. ߂l noErr, paramErr ȊȌꍇArestoreStatePtr ɕԂl𒲂ׂ
				      fXNgbvʂɖ߂̂tXN[ʂ̂܂܂Ȃ̂肷邱				             
				      ifXNgbvʂɖ߂ꍇ̂݃k|C^Ԃj
*/
OSStatus										DSpEndFullScreen(FullScreenStatusRef*	restoreStatePtr,
																 DSpFullScreenFlag		enmFlags);


#ifdef __cplusplus
}
#endif


#endif	/*__DSPFULLSCREEN__*/
