/*
	t@C : SharedLibrary.h
	e         : Carbon LCu[h^A[h[`
	     : Mac OS 9.x : CarbonLib 1.2 ȍ~
				   Mac OS X   : Mac OS X 10.0 ȍ~
	l         : 
*/
#ifndef __SHAREDLIBRARY__
#define __SHAREDLIBRARY__

#ifndef __CARBON__
#include <Carbon.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
	      ֐ : LoadSharedLibrary
	        @\ : LCu[h
	         : FS_PARENT_DIR_PTR      LCui[efBNgւ̎Q
				   strLibName             LCu
				   connIDPtr          o    LCuւ̎Q
	      ߂l : noErr    : 
				   paramErr : FS_PARENT_DIR_PTR, strLibName, connIDPtr Ƀk|C^nꂽ
				   ̑   : G[
	        l : 1. gp UnloadSharedLibrary ֐ŋLCu邱
*/
OSErr											LoadSharedLibrary(const FSRef*			FS_PARENT_DIR_PTR,
																  CFStringRef			strLibName,
																  CFragConnectionID*	connIDPtr);

/*
	      ֐ : LoadSystemSharedLibrary
	        @\ : LCu[h
	         : strLibName      LCu
				   connIDPtr   o    LCuւ̎Q
	      ߂l : noErr    : 
				   paramErr : strLibName, connIDPtr Ƀk|C^nꂽ
				   ̑   : G[
	        l : 1. LCǔΏۂ́Aȉ̏ꏊł
				          EAvP[VƓKw
				          E@\gtH_i Mac OS 9.x ̂݁j
				   2. gp UnloadSharedLibrary ֐ŋLCu邱
*/
OSErr											LoadSystemSharedLibrary(CFStringRef			strLibName,
																		CFragConnectionID*	connIDPtr);

/*
	      ֐ : FindSharedLibrary
	        @\ : [hϋLCu
	         : FS_PARENT_DIR_PTR      LCui[efBNgւ̎Q
				   strLibName             LCu
				   connIDPtr          o    LCuւ̎Q
	      ߂l : noErr    : 
				   paramErr : FS_PARENT_DIR_PTR, strLibName, connIDPtr Ƀk|C^nꂽ
				   ̑   : G[
	        l : 1. AvP[VIAIɋLCuA[h邽߁A
				      UnloadSharedLibrary ֐ŋLCuKv͂Ȃ
				      i UnloadSharedLibrary ֐ŉꍇ͖̓`j
*/
OSErr											FindSharedLibrary(const FSRef*			FS_PARENT_DIR_PTR,
																  CFStringRef			strLibName,
																  CFragConnectionID*	connIDPtr);

/*
	      ֐ : FindSystemSharedLibrary
	        @\ : [hϋLCu
	         : strLibName      LCu
				   connIDPtr   o    LCuւ̎Q
	      ߂l : noErr    : 
				   paramErr : strLibName, connIDPtr Ƀk|C^nꂽ
				   ̑   : G[
	        l : 1. LCǔΏۂ́Aȉ̏ꏊł
				          EAvP[VƓKw
				          E@\gtH_i Mac OS 9.x ̂݁j
				   2. AvP[VIAIɋLCuA[h邽߁A
				      UnloadSharedLibrary ֐ŋLCuKv͂Ȃ
				      i UnloadSharedLibrary ֐ŉꍇ͖̓`j
*/
OSErr											FindSystemSharedLibrary(CFStringRef			strLibName,
																		CFragConnectionID*	connIDPtr);

/*
	      ֐ : GetSharedLibraryProcedureAddress
	        @\ : LCu̎w֐ւ̊֐|C^𓾂
	         : libRef           LCuւ̎Q
				   strProcName      ֐
	      ߂l : w֐ւ̊֐|C^
	        l : 1. ֐̎sɎsꍇANULL |C^Ԃ
*/
ProcPtr											GetSharedLibraryProcedureAddress(CFragConnectionID	connID,
																				 CFStringRef		strProcName);

/*
	      ֐ : UnloadSharedLibrary
	        @\ : LCuA[h
	         : connIDPtr      LCuւ̎Q
				              o    k|C^
	      ߂l : 
	        l : 
*/
void											UnloadSharedLibrary(CFragConnectionID*	connIDPtr);


#ifdef __cplusplus
}
#endif


#endif	/*__SHAREDLIBRARY__*/