/*
	t@C : UserPreference.cpp
	e         : [U[ʐݒt@CIuWFNgC^[tF[X
				   itHgA։̃ev[gꗗ̕ۑj
	     : Mac OS 9.x c Mac OS 8.6 ȍ~ + CarbonLib 1.2 ȍ~
	               Mac OS X   c Mac OS X 10.1 ȍ~
	l         : 1. ev[g^Ɏgpł^ꗗ
	                  CFArrayRef
	                  CFBooleanRef
	                  CFDataRef
	                  CFDateRef
	                  CFDictionaryRef
	                  CFNumberRef
	                  CFStringRef
	                  char*
	                  StringPtr
	                  bool
	                  signed char
	                  short
	                  long
*/

#include "UserPreference.h"


//C^[tF[X`
/*
	ANZXw : protected
	      ֐ : UserPreference::UserPreference
	        @\ : [U[ʐݒt@CIuWFNg̃RXgN^
	         : 
	      ߂l : 
	        O : 
	        l : 
*/
											UserPreference::UserPreference(void)
{
}

/*
	ANZXw : public
	      ֐ : UserPreference::~UserPreference
	        @\ : [U[ʐݒt@CIuWFNg̃fBXgN^
	         : 
	      ߂l : 
	        O : 
	        l : 1. ݒt@C̕ۑi CFPreferencesAppSynchronize API j
	                  hNXŋLq邱
*/
											UserPreference::~UserPreference(void)
{
}

/*
	ANZXw : public
	      ֐ : UserPreference::Remove
	        @\ : wL[폜
	         : strKey      L[
	      ߂l : 
	        O : 
	        l : 
*/
void										UserPreference::Remove(CFStringRef	strKey) throw()
{
	//p[^
	if(NULL == strKey)
		return;

	//
	::CFPreferencesSetAppValue(strKey,
							   NULL,
							   getApplicationID());
}

/*
	ANZXw : public
	      ֐ : UserPreference::setBoolean
	        @\ : wL[ bool ^̒lݒ
	         : strKey      L[
	               bValue      ݒl
	      ߂l : 
	        O : 
	        l : 
*/
void										UserPreference::setBoolean(CFStringRef	strKey,
																	   bool			bValue) throw()
{
	//p[^
	if(NULL == strKey)
		return;

	//
	if(bValue)
		::CFPreferencesSetAppValue(strKey,
								   kCFBooleanTrue,
								   getApplicationID());
	else
		::CFPreferencesSetAppValue(strKey,
								   kCFBooleanFalse,
								   getApplicationID());
}

/*
	ANZXw : public
	      ֐ : UserPreference::setInteger
	        @\ : wL[ɐlݒ
	         : strKey         L[
	               si32Value      ݒl
	      ߂l : 
	        O : 
	        l : 
*/
void										UserPreference::setInteger(CFStringRef	strKey,
																	   CFIndex		si32Value) throw()
{
	//ϐ錾
	CFNumberRef									nValue;

	//p[^
	if(NULL == strKey)
		return;

	//
	nValue = ::CFNumberCreate(kCFAllocatorDefault,
							  kCFNumberMaxType,
							  &si32Value);
	if(NULL != nValue)
	{
		::CFPreferencesSetAppValue(strKey,
								   nValue,
								   getApplicationID());
		::CFRelease(nValue);
	}
}

/*
	ANZXw : public
	      ֐ : UserPreference::setCFObject
	        @\ : wL[ Core Foundation Object ݒ
	         : strKey       L[
	               cfValue      ݒl
	      ߂l : 
	        O : 
	        l : 
*/
void										UserPreference::setCFObject(CFStringRef			strKey,
																		CFPropertyListRef	cfValue) throw()
{
	//p[^
	if(NULL == strKey)
		return;
	if(NULL == cfValue)
		return;

	//
	::CFPreferencesSetAppValue(strKey,
							   cfValue,
							   getApplicationID());
}

/*
	ANZXw : public
	      ֐ : UserPreference::getBooleanIfExists
	        @\ : wL[ɑΉ bool ^̒l擾
	         : strKey         L[
	               bValueRef  o    ݒl
	      ߂l : true  c wL[͑
	               false c wL[݂͑Ȃ
	        O : 
	        l : 
*/
bool										UserPreference::getBooleanIfExists(CFStringRef	strKey,
																			   bool&		bValueRef) throw()
{
	//ϐ錾
	Boolean										blnRet;
	Boolean										blnValid;

	//p[^
	if(NULL == strKey)
		return false;

	//
	blnRet = ::CFPreferencesGetAppBooleanValue(strKey,
											   getApplicationID(),
											   &blnValid);
	bValueRef = (blnRet != FALSE);
	return (blnValid != FALSE);
}

/*
	ANZXw : public
	      ֐ : UserPreference::getIntegerIfExists
	        @\ : wL[ɑΉ鐮l擾
	         : strKey            L[
	               si32ValueRef  o    ݒl
	      ߂l : true  c wL[͑
	               false c wL[݂͑Ȃ
	        O : 
	        l : 
*/
bool										UserPreference::getIntegerIfExists(CFStringRef	strKey,
																			   CFIndex&		si32ValueRef) throw()
{
	//ϐ錾
	CFIndex										si32Ret;
	Boolean										blnValid;

	//p[^
	if(NULL == strKey)
		return false;

	//
	si32Ret = ::CFPreferencesGetAppIntegerValue(strKey,
												getApplicationID(),
												&blnValid);
	si32ValueRef = si32Ret;
	return (blnValid != FALSE);
}

/*
	ANZXw : public
	      ֐ : UserPreference::copyCFObjectIfExists
	        @\ : wL[ɑΉ Core Foundation Object 擾
	         : strKey          L[
	               cfValueRef  o    ݒl
	      ߂l : true  c wL[͑
	               false c wL[݂͑Ȃ
	        O : 
	        l : 1. ֐߂ĺAgp ::CFRelease() API ŉ邱
*/
bool										UserPreference::copyCFObjectIfExists(CFStringRef		strKey,
																				 CFPropertyListRef&	cfValueRef) throw()
{
	//p[^
	if(NULL == strKey)
		return false;

	//
	cfValueRef = ::CFPreferencesCopyAppValue(strKey,
											 getApplicationID());
	return (NULL != cfValueRef);
}