/*=======================================================================
  AVG32-like scriptor for Macintosh
  Copyright 2000, K.Takagi(Kenjo)

  pdtbuf.cpp
    PDTobt@
=======================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "pdtbuf.h"
#include "debug.h"

/************************************************************************
  class PDTBUF
    摜obt@
************************************************************************/

PDTBUFFER::PDTBUFFER(int x, int y, int p, int l, bool flag)
{
	xsize = x;
	ysize = y;
	bpp = p;			// Bytes per Pixel
	bpl = l;			// Bytes per Line
	mask = NULL;
	buffer = NULL;
	if ( flag ) {
		buffer = new unsigned char[x*y*p];
		bufdel = true;	// fXgN^Ńobt@
		memset(buffer, 0, x*y*p);
	} else {
		buffer = 0;
		bufdel = false;	// obt@ʊmۂĂ鎞͏Ȃi\PDTpj
	}
	mask = new unsigned char[x*y];
	memset(mask, 255, x*y);
};

PDTBUFFER::~PDTBUFFER(void)
{
	if (bufdel) delete[] buffer;
	delete[] mask;
};
