/*=======================================================================
  AVG32-like scriptor for Macintosh
  Copyright 2000, K.Takagi(Kenjo)

  soundmgr.h
     TEhǗNX

  ύX
      2001/11/15 : F.Shiraishi
				   CN[ht@C Movies.h ǉ
      2001/11/15 : F.Shiraishi
				   TARGET_CARBON }N TARGET_API_MAC_CARBON }NɕύX
      2001/11/15 : F.Shiraishi
				   oϐ Boolean ^ bIsOSXistOjǉ
				    TRUE : Mac OSX Ŏs
				   FALSE : Mac OS 9.x 邢 Classic Ŏs
      2001/12/14 : F.Shiraishi
				   Mac OS X  CD-DA Đ邽߁ASOUND IuWFNgč\z
				   i2001/11/15 ܂ł̃o[W Old Sound Manager tH_ɗL܂j
						a). CD-DA tɁAOS ̃o[WɈˑȂ CD-DA tC^[tF[X
						    񋟂 CDDA IuWFNggpBɔC{

	  2001/12/18 : F.Shiraishi
					։gp̉t[` CDDA IuWFNgɓB
					̂߂̏C{B
					ύX֐
						SOUND::SOUND
						SOUND::~SOUND
						SOUND::Sound_CheckPlay
						SOUND::CD_Play
						SOUND::CD_Stop
						SOUND::CD_FadeOut
						SOUND::CD_FadeIn
						SOUND::CDDA_Play
						SOUND::CDDA_Stop
						SOUND::CDDA_CheckPlay
						SOUND::CDDA_SetVolume
						SOUND::CDDA_GetVolume
					ύX@
						ȑȎ։gpt[`ŎgpĂoϐ̍폜

	  2001/02/13 : F.Shiraishi
                    ։̃ev[gi։̌ɎgpjO󂯎悤ɉ
                    ύX֐
                        SOUND::SOUND
					ύX@
						RXgN^̈ɑ։̃ev[gz tmpl ǉ

=======================================================================*/

#ifndef _avg32sound_h
#define _avg32sound_h

class  SYSTEM;
class  SOUNDWAV;
class  SOUNDKOE;
struct INIFILE;
class  CDDA;
class SOUND
{
private:
	SYSTEM*		sys;
	INIFILE*	ini;
	SOUNDWAV*	bgm;
	SOUNDWAV*	wav;
	SOUNDKOE*	koe;
	int			CD_LoopFlag;
	int			WAV_LoopFlag;
	int			VolL;
	int			VolR;
	int			CD_FadeTime;
	int			CD_FadeTimeBase;
	int			WAV_FadeTime;
	int			WAV_FadeTimeBase;
	char		CurBGMName[64];
	int			CurTrack;
	int			KOE_SW;
	//CD-DA tIuWFNg
	CDDA*		cdObj;

	void CDDA_Play(char* trk);
	void CDDA_Stop(void);
	void CDDA_CheckPlay(void);
	void CDDA_SetVolume(int n);
	int  CDDA_GetVolume(void);

	void DS_Play(char* trk, int loop);
	void DS_Stop(void);
	void DS_CheckPlay(void);
	void DS_SetVolume(int l, int r);
	void DS_GetVolume(int* l, int* r);

public:
	SOUND(SYSTEM* sys, INIFILE* ini, CFArrayRef tmpl = NULL);
	~SOUND(void);
	void Reset(void);

	void CD_Play(char* trk, int loop);
	void CD_Stop(void);
	void CD_FadeOut(int n);
	void CD_FadeIn(char* trk, int loop, int n);
	void CD_Rewind(void);
	void CD_CheckPlay(void);

	void Sound_Play(char* f, int loop);
	void Sound_Stop(void);
	void Sound_CheckPlay(void);
	int  Sound_IsPlaying(void);

	void KOE_Play(int id);
	void KOE_Stop(void);
	int  KOE_IsPlaying(void);
	void KOE_Disable(int sw);

	char* GetCurrentBGM(void) { return CurBGMName; };
};

#endif
