/*=======================================================================
  AVG32-like scriptor for Macintosh
  Copyright 2000, K.Takagi(Kenjo)

  soundwav.h
     WAVTEhǗNX

  ύX
      2001/11/15 : F.Shiraishi
				   Carbon łł Sound.h ̂ Carbon.h CN[h悤ɕύX
      2001/11/15 : F.Shiraishi
				   TARGET_CARBON }N TARGET_API_MAC_CARBON }NɕύX
      2001/11/15 : F.Shiraishi
      			   Carbon łł̃RpCG[΍s
      					EWAVFILEINFO \̂ buf  oi SndDoubleBufferPtr     ^j
						   Carbon łł͒`Ȃ悤ɕύX
						ESOUNDWAV    NX head oi SndDoubleBufferHeader2 ^j
						   Carbon łł͒`Ȃ悤ɕύX
      2003/01/06 : tmkk
      			   SOUNDKOE::Play()̈SEEN.TXT󂯎KOE IDi[ϐǉ
      2003/09/01 : tmkk
      			   Carbon̏ꍇAKOENX̃oϐMovie mWAVǉ
=======================================================================*/

#ifndef _soundwav_h
#define _soundwav_h

#include <QuickTime/QuickTimeComponents.h>

//2001/11/15 ǉ F.Shiraishi
#if !TARGET_API_MAC_CARBON
//ǉI

#include <Sound.h>

//2001/11/15 ǉ F.Shiraishi
#else

#ifndef __CARBON__
#include "Carbon.h"
#endif

#endif	//!TARGET_API_MAC_CARBON
//ǉI

#define SNDBUFSIZE 44100		// 4Ŋ؂[ɂƂĂˁi1frameő傪16bit x stereoȂ̂Łj


/************************************************************************
  class SOUNDWAV
************************************************************************/

// WAVf[^ߗvR[obNɓnf[^
struct WAVINFO {
	int playflag;			// ĐtO
	int playingflag;		// ĐtO
	int loopflag;			// [vĐ
	int start;				// WAVf[^́At@C擪̃ItZbg
	int end;				// f[^I[ʒu
	int repeat;				// s[g̊߂ʒu
	int pos;				// ݂̃t@C|Cg
	int channel;			// `li1:mono 2:stereo)
	int bits;				// f[^rbgi8 or 16j
	int linear;				//  `ktO
	long backupedA5;		// A5̃obNAbv
};


// t@CǂݍݏIR[obNɓnf[^iParamBlockRec̊gj
struct WAVFILEINFO {
	ParamBlockRec pb;			// p[^ubNR[hiPBReadAsyncŎgpj

//2001/11/15 ǉ F.Shiraishi
#if !TARGET_API_MAC_CARBON
//ǉI

	SndDoubleBufferPtr buf;		// DoubleBuffer̕Ђۂ̃|C^

//2001/11/15 ǉ F.Shiraishi
#endif	//!TARGET_API_MAC_CARBON
//ǉI

	int num;					// obt@ԍi01j
	int inuse;					// fBXNǂݍݎstO
	WAVINFO* wav;				// WAVINFOւ̃|C^
};


class SOUNDWAV
{
private:
	SndChannelPtr hsnd;
	WAVFILEINFO wfile[2];
	WAVINFO wav;
	IOCompletionUPP ioc;
	SndCallBackUPP sndcb;
	int linear;
	
	Movie	mWAV;

public:
	SOUNDWAV(int l);
	~SOUNDWAV(void);

	void Play( char *f, int loop, int cutsize);
	void Play2( FSSpec *, int, int );

	void Stop(void);
	void GetVolume(int* l, int* r);
	void SetVolume(int l, int r);
	int IsPlaying(void);

	void LoopCheck();

};



/************************************************************************
  class SOUNDKOE
 ***********************************************************************/
struct KOETABLE {
	short id;
	short symbol;
	unsigned int pos;
};

class SOUNDKOE
{
private:
	SndChannelPtr hsnd;
	ExtSoundHeader head;
	SndCallBackUPP sndcb;

	KOETABLE* table;
	int tableid;
	int maxnum;
	int rate;
	signed short* koebuf;
	int playflag;
	int koetype;
	int linear;

	void MakeTable(char* f, int tid);

	short table1[256];
	unsigned char table2[256];
	//short table2[256];
	
#if TARGET_API_MAC_CARBON
	
	Movie	mWAV;
	
#endif

public:
	SOUNDKOE(int type, int l);
	~SOUNDKOE(void);

	void Play(char* f, int tid, int id, int name);
	void Stop(void);
	int IsPlaying(void);
};

#endif
